C-+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C- Version MonCHER 1.0.0 /R.Ryutin,A.Sobol ++++++++++++++++
C-+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      PROGRAM  MAIN 
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
c-...global MONCHER parameters
      INTEGER MXGLPAR      
      REAL GENPAR
      PARAMETER   (MXGLPAR=200)
      COMMON /MONCHERGLPAR/ GENPAR(MXGLPAR)

c-- initialization 
      CALL MONCHERINI
c
      NTOT=GENPAR(1)       
      KLHE=GENPAR(2)
c      
c-- generation             
      DO NEV=1,NTOT
        CALL MONCHEREVE
        IF(KLHE.EQ.1) CALL MONCHER_PYUPEV_ST
        IF(NEV.LE.3)  CALL PYLIST(1)
      ENDDO 

C...Final statistics.
      CALL PYSTAT(1)

C...Produce final Les Houches Event File.
      IF(KLHE.EQ.1) CALL PYLHEF
    
      STOP
      END            
c-====================================================
c MONCHER initialization  A.Sobol
c-====================================================
c
      SUBROUTINE MONCHERINI
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
C
      EXTERNAL NTAB
C
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
      EXTERNAL PYDATA
C
*...Standard PYTHIA ( v. >= 6.1) commons for initialization.
      COMMON /PYJETS/ N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYDAT4/CHAF(500,2)
      COMMON/PYDATR/MRPY(6),RRPY(100)
      CHARACTER CHAF*16
      COMMON /PYSUBS/ MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON /PYINT1/ MINT(400),VINT(400)
C...HEPEVT commonblock.
      PARAMETER (NMXHEP=4000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      DOUBLE PRECISION PHEP,VHEP
      SAVE /HEPEVT/
c-...global MONCHER parameters
      INTEGER MXGLPAR      
      REAL GENPAR
      PARAMETER   (MXGLPAR=200)
      COMMON /MONCHERGLPAR/ GENPAR(MXGLPAR)
c--------- general parameters ------------------------ 
      DOUBLE PRECISION XSQ,PI,MPI,MP,MN,MRHO,MA2
      DOUBLE PRECISION XIMIN,XIMAX,QTMIN,QTMAX
      DOUBLE PRECISION API,ARHO,AA2,R2PI,R2RHO,R2A2
      DOUBLE PRECISION GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION S
      INTEGER NMODPP,NMODRR,ITYPR
      COMMON/PNTAB0/S,NMODPP,NMODRR,ITYPR
      COMMON/PNTAB1/XSQ(6),PI,MPI,MP,MN,MRHO,MA2
      COMMON/PNTAB2/XIMIN,XIMAX,QTMIN,QTMAX
      COMMON/PNTAB3/API,ARHO,AA2,R2PI,R2RHO,R2A2
      COMMON/PNTAB4/GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
c
      CALL MONCHERTITLE      
      CALL GETGENPAR                ! Read data card moncher.par
      ECM     =GENPAR(3)
      NMODRR  =GENPAR(4)
      NMODPP  =GENPAR(5)
      ITYPR   =GENPAR(6)
      ICE     =GENPAR(7)  
      IDCE    =GENPAR(8)  
c
      S=ECM*ECM 
c
      CALL MBDEF
      IF(ICE.EQ.1.OR.IDCE.EQ.1) THEN
       CALL CEPUTDAT
       PRINT*,'CM energy = ',ECM,' GeV'
       IF(ICE.EQ.1) THEN
        PRINT*,'pp->n(pi+p)->nX  cs =',CS(1,1),' mb'
        PRINT*,'pp->n(rho+p)->nX cs =',CS(1,2),' mb'
        PRINT*,'pp->n(a2+p)->nX  cs =',CS(1,3),' mb'
       ENDIF
       IF(IDCE.EQ.1) THEN
        PRINT*,'pp->n(pi+pi+)n->nXn  cs =',CS(2,1),' mb'
        PRINT*,'pp->n(pi+rho+)n->nXn cs =',CS(2,2),' mb'
        PRINT*,'pp->n(pi+a2+)n->nXn  cs =',CS(2,3),' mb'
       ENDIF
      ELSE  
       CALL PYINIT('CMS','P','P',ECM)
      ENDIF 
C
C...Temporary files for initialization/event output.
      IF(GENPAR(2).EQ.1) THEN
       MSTP(161)=77
       OPEN(77,FILE='moncher.init',STATUS='unknown')
       MSTP(162)=78
       OPEN(78,FILE='moncher.evnt',STATUS='unknown')

C...Final Les Houches Event File, obtained by combining above two.
       MSTP(163)=79
       OPEN(79,FILE='moncher.lhe',STATUS='unknown')
c      MSTP(164) = 1
       CALL MONCHER_PYUPIN
c      CALL PYUPIN
      ENDIF      
C
      RETURN
      END
c-====================================================
c MONCHER event generation  A.Sobol
c-====================================================
c
      SUBROUTINE MBDEF
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
c minimum bias definition
c  from Configuration/Generator/python/PythiaMinBias_cfi.py                                                                                           
            CALL PYGIVE('MSTJ(11)=3')     ! Choice of the fragmentation function',
            CALL PYGIVE('MSTJ(22)=2')     ! Decay those unstable particles',
            CALL PYGIVE('PARJ(71)=10.')   ! for which ctau  10 mm',
            CALL PYGIVE('MSTP(2)=1')      ! which order running alphaS',
            CALL PYGIVE('MSTP(33)=0')     ! no K factors in hard cross sections',
            CALL PYGIVE('MSTP(51)=7')     ! choice of proton parton-distribution set (D=7 and means CTEQ 5L)',
            CALL PYGIVE('MSTP(52)=1')     ! choice of proton pdf library (D=1 and means internal pythia one, according to MSTP(51) above',
            CALL PYGIVE('MSTP(81)=1')     ! multiple parton interactions 1 is Pythia default',
            CALL PYGIVE('MSTP(82)=4')     ! Defines the multi-parton model',
            CALL PYGIVE('MSTU(21)=1')     ! Check on possible errors during program execution',
            CALL PYGIVE('PARP(82)=1.9409')   ! pt cutoff for multiparton interactions',
            CALL PYGIVE('PARP(89)=1960.') ! sqrts for which PARP82 is set',
            CALL PYGIVE('PARP(83)=0.5')   ! Multiple interactions: matter distrbn parameter',
            CALL PYGIVE('PARP(84)=0.4')   ! Multiple interactions: matter distribution parameter',
            CALL PYGIVE('PARP(90)=0.16')  ! Multiple interactions: rescaling power',
            CALL PYGIVE('PARP(67)=2.5')    ! amount of initial-state radiation',
            CALL PYGIVE('PARP(85)=1.0')  ! gluon prod. mechanism in MI',
            CALL PYGIVE('PARP(86)=1.0')  ! gluon prod. mechanism in MI',
            CALL PYGIVE('PARP(62)=1.25')   ! ',
            CALL PYGIVE('PARP(64)=0.2')    ! ',
            CALL PYGIVE('MSTP(91)=1')     !',
            CALL PYGIVE('PARP(91)=2.1')   ! kt distribution',
            CALL PYGIVE('PARP(93)=15.0')  !')
      RETURN
      END
c-====================================================
c MONCHER event generation  A.Sobol
c-====================================================
c
      SUBROUTINE MONCHEREVE
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
c-...global MONCHER parameters
      INTEGER MXGLPAR      
      REAL GENPAR
      PARAMETER   (MXGLPAR=200)
      COMMON /MONCHERGLPAR/ GENPAR(MXGLPAR)
c
      ICE     =GENPAR(7)  
      IDCE    =GENPAR(8)  
       IF(ICE.EQ.1.OR.IDCE.EQ.1)  THEN 
        IF(ICE.EQ.1)  CALL CEEVE
        IF(IDCE.EQ.1) CALL DCEEVE
       ELSE	
        CALL PYEVNT
       ENDIF  
      RETURN
      END
c-====================================================
c CE events generation  A.Sobol
c-====================================================
c
      SUBROUTINE CEEVE
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
      EXTERNAL PYDATA
*...Standard PYTHIA ( v. >= 6.1) commons for initialization.
      COMMON /PYJETS/ N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYDAT4/CHAF(500,2)
      CHARACTER CHAF*16
      COMMON /PYSUBS/ MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON /PYINT1/ MINT(400),VINT(400)
C...HEPEVT commonblock.
      PARAMETER (NMXHEP=4000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      DOUBLE PRECISION PHEP,VHEP
      SAVE /HEPEVT/
c-...global MONCHER parameters
      INTEGER MXGLPAR      
      REAL GENPAR
      PARAMETER   (MXGLPAR=200)
      COMMON /MONCHERGLPAR/ GENPAR(MXGLPAR)
C...for p>npi+ generation 
      EXTERNAL NTAB
c     DOUBLE PRECISION PN(5),PPI(5)        
c      DOUBLE PRECISION MPI,MP,MN,S,PI,XIMAX,XIMIN,API,B1,G2
c      COMMON/PNTAB1/MPI,MP,MN,S,PI,XIMAX,XIMIN,API,B1,G2 
c--------- general parameters ------------------------ 
      DOUBLE PRECISION XSQ,PI,MPI,MP,MN,MRHO,MA2
      DOUBLE PRECISION XIMIN,XIMAX,QTMIN,QTMAX
      DOUBLE PRECISION API,ARHO,AA2,R2PI,R2RHO,R2A2
      DOUBLE PRECISION GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION S
      INTEGER NMODPP,NMODRR,ITYPR
      COMMON/PNTAB0/S,NMODPP,NMODRR,ITYPR
      COMMON/PNTAB1/XSQ(6),PI,MPI,MP,MN,MRHO,MA2
      COMMON/PNTAB2/XIMIN,XIMAX,QTMIN,QTMAX
      COMMON/PNTAB3/API,ARHO,AA2,R2PI,R2RHO,R2A2
      COMMON/PNTAB4/GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION PRR(5),PNN(5),MM2,PRR1(5),PRR2(5)
C 
       ECMH=GENPAR(3)/2     
       CALL CEMOM(ITYPR,PNN,PRR,MM2)
C       PRINT*,PPI(1),PPI(2),PPI(3),PPI(4),PPI(5)
C       PRINT*,PN(1),PN(2),PN(3),PN(4),PN(5)
C	PRINT*,PPI(4)**2-PPI(3)**2-PPI(2)**2-PPI(1)**2
       IF(PYR(0).LE.0.5) THEN
	 DO I=1,3
	  PNN(I)=-PNN(I)
	  PRR(I)=-PRR(I)
	 ENDDO 
       ENDIF
          P(1,1)=0.0
          P(1,2)=0.0
          P(1,3)=DSIGN(DSQRT(ECMH**2-MP**2),-PNN(3))
          P(1,4)=ECMH
          P(1,5)=MP  
          P(2,1)=PRR(1)
          P(2,2)=PRR(2)
          P(2,3)=PRR(3)
          P(2,4)=PRR(4)
          P(2,5)=-DSQRT(DABS(PRR(4)**2-PRR(3)**2-PRR(2)**2-PRR(1)**2))
        MSTP(122)=0
c        CALL PYINIT('5MOM','PI+','P',0.0)
        CALL PYINIT('3MOM','P','PI+',0.0)
c        IF(NMODRR.EQ.1) CALL PYINIT('3MOM','P','PI+',0.0)
c        IF(NMODRR.EQ.2) CALL PYINIT_pnpx('3MOM','P','RHO+',0.0)
c        IF(NMODRR.EQ.3) CALL PYINIT('3MOM','P','A_2+',0.0)
        CALL PYEVNT
	CALL SHIFTPYT(2)
	NS=N
	CALL PY1ENT(1,2212,ECMH,0.0D0,0.0D0)
	CALL PY1ENT(2,2212,ECMH,PI,0.0D0)
	N=NS
	TET=PYANGL(PNN(3),DSQRT(PNN(1)**2+PNN(2)**2))
	PHI=PYANGL(PNN(1),PNN(2))
	CALL PY1ENT(3,2112,PNN(4),TET,PHI)
	N=NS
	K(1,1)=21
   	K(2,1)=21 
	IF(PNN(3).GT.0) THEN    
	K(1,4)=3
	K(1,5)=4
	K(2,4)=0
	K(2,5)=0
	K(3,3)=1
	K(4,3)=1
	ELSE
	K(1,4)=0
	K(1,5)=0
	K(2,4)=3
	K(2,5)=4
	K(3,3)=2	
	K(4,3)=2
	ENDIF
      MINT(1)=MINT(1)+400+(NMODRR-1)*1000
c        call pylist(1)
      RETURN
      END
c-====================================================
c DCE events generation  A.Sobol
c-====================================================
c
      SUBROUTINE DCEEVE
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
      EXTERNAL PYDATA
*...Standard PYTHIA ( v. >= 6.1) commons for initialization.
      COMMON /PYJETS/ N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYDAT4/CHAF(500,2)
      CHARACTER CHAF*16
      COMMON /PYSUBS/ MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON /PYINT1/ MINT(400),VINT(400)
C...HEPEVT commonblock.
      PARAMETER (NMXHEP=4000)
      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
      DOUBLE PRECISION PHEP,VHEP
      SAVE /HEPEVT/
c-...global MONCHER parameters
      INTEGER MXGLPAR      
      REAL GENPAR
      PARAMETER   (MXGLPAR=200)
      COMMON /MONCHERGLPAR/ GENPAR(MXGLPAR)
C...for p>npi+ generation 
      EXTERNAL NTAB
c      DOUBLE PRECISION PN1(5),PPI1(5)        
c      DOUBLE PRECISION PN2(5),PPI2(5)        
c      DOUBLE PRECISION MPI,MP,MN,S,PI,XIMAX,XIMIN,API,B1,G2
c      COMMON/PNTAB1/MPI,MP,MN,S,PI,XIMAX,XIMIN,API,B1,G2 
c--------- general parameters ------------------------ 
      DOUBLE PRECISION XSQ,PI,MPI,MP,MN,MRHO,MA2
      DOUBLE PRECISION XIMIN,XIMAX,QTMIN,QTMAX
      DOUBLE PRECISION API,ARHO,AA2,R2PI,R2RHO,R2A2
      DOUBLE PRECISION GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION S
      INTEGER NMODPP,NMODRR,ITYPR
      COMMON/PNTAB0/S,NMODPP,NMODRR,ITYPR
      COMMON/PNTAB1/XSQ(6),PI,MPI,MP,MN,MRHO,MA2
      COMMON/PNTAB2/XIMIN,XIMAX,QTMIN,QTMAX
      COMMON/PNTAB3/API,ARHO,AA2,R2PI,R2RHO,R2A2
      COMMON/PNTAB4/GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION PRR(5),PNN(5),MM2,PRR1(5),PRR2(5)
      DOUBLE PRECISION PNN1(5),PNN2(5)
C 
       ECMH=GENPAR(3)/2     
       CALL DCEMOM(ITYPR,PNN1,PNN2,PRR1,PRR2,MM2)
c       PRINT*,PRR1(1),PRR1(2),PRR1(3),PRR1(4),PRR1(5)
c       PRINT*,PRR2(1),PRR2(2),PRR2(3),PRR2(4),PRR2(5)
c       PRINT*,PNN1(1),PNN1(2),PNN1(3),PNN1(4),PNN1(5)
c       PRINT*,PNN2(1),PNN2(2),PNN2(3),PNN2(4),PNN2(5)
C	PRINT*,PPI(4)**2-PPI(3)**2-PPI(2)**2-PPI(1)**2
          P(1,1)=PRR1(1)
          P(1,2)=PRR1(2)
          P(1,3)=PRR1(3)
          P(1,4)=PRR1(4)
          P(1,5)=-DSQRT(DABS(PRR1(4)**2-
     &	  PRR1(3)**2-PRR1(2)**2-PRR1(1)**2))
          P(2,1)=PRR2(1)
          P(2,2)=PRR2(2)
          P(2,3)=PRR2(3)
          P(2,4)=PRR2(4)
          P(2,5)=-DSQRT(DABS(PRR2(4)**2-
     &	  PRR2(3)**2-PRR2(2)**2-PRR2(1)**2))
        MSTP(122)=0
cc        CALL PYINIT('5MOM','PI+','PI+',0.0)
        CALL PYINIT('3MOM','PI+','PI+',0.0)
        CALL PYEVNT
	CALL SHIFTPYT(4)
	NS=N
	CALL PY1ENT(1,2212,ECMH,0.D0,0.D0)
	CALL PY1ENT(2,2212,ECMH,PI,0.D0)
	K(1,1)=21
	K(2,1)=21
	K(1,4)=3
	K(1,5)=5
	K(2,4)=4
	K(2,5)=6
	TET=PYANGL(PNN1(3),DSQRT(PNN1(1)**2+PNN1(2)**2))
	PHI=PYANGL(PNN1(1),PNN1(2))
	CALL PY1ENT(3,2112,PNN1(4),TET,PHI)
	TET=PYANGL(PNN2(3),DSQRT(PNN2(1)**2+PNN2(2)**2))
	PHI=PYANGL(PNN2(1),PNN2(2))
	CALL PY1ENT(4,2112,PNN2(4),TET,PHI)
	K(3,3)=1
	K(4,3)=2
	K(5,3)=1
	K(6,3)=2
	N=NS
        MINT(1)=MINT(1)+500+(NMODRR-1)*1000
C	CALL PYLIST(1)
      RETURN
      END
c-====================================================
c Cross sections for CE and DCE  R.Ryutin
c-====================================================
c- KP - 1 - CE, 2 - DCE
c- KR - type of exchange Reggeon
c-      1 - pi, 2 - rho, 3 - a2

      FUNCTION CS(KP,KR)
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
c-...global MONCHER parameters
      INTEGER MXGLPAR      
      REAL GENPAR
      PARAMETER   (MXGLPAR=200)
      COMMON /MONCHERGLPAR/ GENPAR(MXGLPAR)
c--------- tables for absorbtion and form-factors ----
      DOUBLE PRECISION SPIX1,SPIX2,SPIXQ,SROX1,SROX2,SROXQ,
     & SA2X1,SA2X2,SA2XQ,DPIX1,DPIX2,DPIXX,
     & DROX1,DROX2,DROXX,DA2X1,DA2X2,DA2XX,
     & DDPI1,DDPI2,DDPI3,DDRO1,DDRO2,DDRO3,
     & DDA21,DDA22,DDA23
      COMMON/CEDATGEN/SPIX1(41),SPIX2(41),SPIXQ(2,41,41),
     & SROX1(41),SROX2(41),SROXQ(2,41,41),
     & SA2X1(41),SA2X2(41),SA2XQ(2,41,41),
     & DPIX1(17),DPIX2(17),DPIXX(2,17,17),
     & DROX1(17),DROX2(17),DROXX(2,17,17),
     & DA2X1(17),DA2X2(17),DA2XX(2,17,17),
     & DDPI1(4,17,17,17),DDPI2(4,17,17,17),DDPI3(8,17,17,17,17),
     & DDRO1(4,17,17,17),DDRO2(4,17,17,17),DDRO3(8,17,17,17,17),
     & DDA21(4,17,17,17),DDA22(4,17,17,17),DDA23(8,17,17,17,17)
     
      KPROCESS=KP
      IF(KPROCESS.EQ.1.AND.KR.EQ.1) CS=SPIX2(41)
      IF(KPROCESS.EQ.1.AND.KR.EQ.2) CS=SROX2(41)
      IF(KPROCESS.EQ.1.AND.KR.EQ.3) CS=SA2X2(41)
      IF(KPROCESS.EQ.2.AND.KR.EQ.1) CS=DPIX2(17)
      IF(KPROCESS.EQ.2.AND.KR.EQ.2) CS=DROX2(17)
      IF(KPROCESS.EQ.2.AND.KR.EQ.3) CS=DA2X2(17)
      
      RETURN
      END       
c-====================================================
c MonCHER LOGO  A.Sobol
c-====================================================
      SUBROUTINE MONCHERTITLE
      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
       
      WRITE(*,*)'*********************************'
      WRITE(*,*)'*                               *'
      WRITE(*,*)'*  MON-te-carlo generator for   *'
      WRITE(*,*)'*     CH-arge                   *'
      WRITE(*,*)'*       E-xchange               *'
      WRITE(*,*)'*        R-eactions             *'
      WRITE(*,*)'*                               *'
      WRITE(*,*)'*  Version 1.0.0 (12/03/2011)   *'
      WRITE(*,*)'*                               *'
      WRITE(*,*)'*  By Diffractive groupe:       *'
      WRITE(*,*)'*  ------------------           *'      
      WRITE(*,*)'*  V.Petrov,R.Ryutin,A.Sobol    *'
      WRITE(*,*)'*            (IHEP,Protvino)    *'
      WRITE(*,*)'*                               *'
      WRITE(*,*)'*********************************'

      RETURN
      END
c-====================================================
c shift particles in PYJETS  A.Sobol
c-====================================================
c
      SUBROUTINE SHIFTPYT(NSHIFT)
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
C...Three Pythia functions return integers, so need declaring.
      INTEGER PYK,PYCHGE,PYCOMP
      EXTERNAL PYDATA
*...Standard PYTHIA ( v. >= 6.1) commons for initialization.
      COMMON /PYJETS/ N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYDAT4/CHAF(500,2)
      CHARACTER CHAF*16
      COMMON /PYSUBS/ MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON /PYINT1/ MINT(400),VINT(400)
C
      DO I=N,1,-1
       DO J=1,5
	K(I+NSHIFT,J)=K(I,J)
        P(I+NSHIFT,J)=P(I,J)
        V(I+NSHIFT,J)=V(I,J)
	IF(J.GE.3.AND.K(I,J).NE.0) K(I+NSHIFT,J)=K(I,J)+NSHIFT
       ENDDO     
      ENDDO
      DO I=1,NSHIFT
       DO J=1,5
        K(I,J)=0
        P(I,J)=0
        V(I,J)=0
       ENDDO     
      ENDDO
      N=N+NSHIFT
C        
      RETURN
      END
c-====================================================
c read initual parameters from moncher.par card file /A.Sobol
c-====================================================
      SUBROUTINE GETGENPAR
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
C
      CHARACTER CPAR*20       
C
      OPEN(99,FILE='moncher.par',STATUS='old')
      ILINE=0
    1  READ(99,'(A)',END=2, ERR=3) CPAR
       ILINE=ILINE+1
c       print*,cpar
       IF(CPAR(1:1).NE.'c') CALL PYGIVE_MONCHER(CPAR)
       GOTO 1
    2 CLOSE(99)
C     
      RETURN
    3 WRITE(*,*) 'Error in  par. card reading, line:',ILINE+1   
      END
C*********************************************************************
 
C...PYGIVE
C...Sets values of commonblock variables.
 
      SUBROUTINE PYGIVE_MONCHER(CHIN)
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
      INTEGER PYK,PYCHGE,PYCOMP
c-...global MONCHER parameters
      INTEGER     MXGLPAR      
      REAL GENPAR
      PARAMETER   (MXGLPAR=200)
      COMMON /MONCHERGLPAR/ GENPAR(MXGLPAR)
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYDAT4/CHAF(500,2)
      CHARACTER CHAF*16
      COMMON/PYDATR/MRPY(6),RRPY(100)
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT1/MINT(400),VINT(400)
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
      COMMON/PYINT3/XSFX(2,-40:40),ISIG(1000,3),SIGH(1000)
      COMMON/PYINT4/MWID(500),WIDS(500,5)
      COMMON/PYINT5/NGENPD,NGEN(0:500,3),XSEC(0:500,3)
      COMMON/PYINT6/PROC(0:500)
      CHARACTER PROC*28
      COMMON/PYINT7/SIGT(0:6,0:6,0:5)
      COMMON/PYINT8/XPVMD(-6:6),XPANL(-6:6),XPANH(-6:6),XPBEH(-6:6),
     &XPDIR(-6:6)
      COMMON/PYMSSM/IMSS(0:99),RMSS(0:99)
      COMMON/PYMSRV/RVLAM(3,3,3), RVLAMP(3,3,3), RVLAMB(3,3,3)
      COMMON/PYTCSM/ITCM(0:99),RTCM(0:99)
      COMMON/PYPUED/IUED(0:99),RUED(0:99)
      SAVE /PYJETS/,/PYDAT1/,/PYDAT2/,/PYDAT3/,/PYDAT4/,/PYDATR/,
     &/PYSUBS/,/PYPARS/,/PYINT1/,/PYINT2/,/PYINT3/,/PYINT4/,/PYINT5/,
     &/PYINT6/,/PYINT7/,/PYINT8/,/PYMSSM/,/PYMSRV/,/PYTCSM/,/PYPUED/
C...Local arrays and character variables.
      CHARACTER CHIN*(*),CHFIX*104,CHBIT*104,CHOLD*8,CHNEW*8,CHOLD2*28,
     &CHNEW2*28,CHNAM*6,CHVAR(57)*6,CHALP(2)*26,CHIND*8,CHINI*10,
     &CHINR*16,CHDIG*10
      DIMENSION MSVAR(57,8)
 
C...For each variable to be translated give: name,
C...integer/real/character, no. of indices, lower&upper index bounds.
      DATA CHVAR/'N','K','P','V','MSTU','PARU','MSTJ','PARJ','KCHG',
     &'PMAS','PARF','VCKM','MDCY','MDME','BRAT','KFDP','CHAF','MRPY',
     &'RRPY','MSEL','MSUB','KFIN','CKIN','MSTP','PARP','MSTI','PARI',
     &'MINT','VINT','ISET','KFPR','COEF','ICOL','XSFX','ISIG','SIGH',
     &'MWID','WIDS','NGEN','XSEC','PROC','SIGT','XPVMD','XPANL',
     &'XPANH','XPBEH','XPDIR','IMSS','RMSS','RVLAM','RVLAMP','RVLAMB',
     &'ITCM','RTCM','IUED','RUED','GENPAR'/
      DATA ((MSVAR(I,J),J=1,8),I=1,57)/ 1,7*0,  1,2,1,4000,1,5,2*0,
     &2,2,1,4000,1,5,2*0,  2,2,1,4000,1,5,2*0,  1,1,1,200,4*0,
     &2,1,1,200,4*0,  1,1,1,200,4*0,  2,1,1,200,4*0,
     &1,2,1,500,1,4,2*0,  2,2,1,500,1,4,2*0,  2,1,1,2000,4*0,
     &2,2,1,4,1,4,2*0,  1,2,1,500,1,3,2*0,  1,2,1,8000,1,2,2*0,
     &2,1,1,8000,4*0,  1,2,1,8000,1,5,2*0,  3,2,1,500,1,2,2*0,
     &1,1,1,6,4*0,  2,1,1,100,4*0,
     &1,7*0,  1,1,1,500,4*0,  1,2,1,2,-40,40,2*0,  2,1,1,200,4*0,
     &1,1,1,200,4*0,  2,1,1,200,4*0,  1,1,1,200,4*0,  2,1,1,200,4*0,
     &1,1,1,400,4*0,  2,1,1,400,4*0,  1,1,1,500,4*0,
     &1,2,1,500,1,2,2*0,  2,2,1,500,1,20,2*0,  1,3,1,40,1,4,1,2,
     &2,2,1,2,-40,40,2*0,  1,2,1,1000,1,3,2*0,  2,1,1,1000,4*0,
     &1,1,1,500,4*0,   2,2,1,500,1,5,2*0,   1,2,0,500,1,3,2*0,
     &2,2,0,500,1,3,2*0,   4,1,0,500,4*0,   2,3,0,6,0,6,0,5,
     &2,1,-6,6,4*0,     2,1,-6,6,4*0,    2,1,-6,6,4*0,
     &2,1,-6,6,4*0,  2,1,-6,6,4*0,  1,1,0,99,4*0,  2,1,0,99,4*0,
     &2,3,1,3,1,3,1,3,   2,3,1,3,1,3,1,3,   2,3,1,3,1,3,1,3,
     &1,1,0,99,4*0,  2,1,0,99,4*0,  1,1,0,99,4*0,  2,1,0,99,4*0,
     &2,1,1,200,4*0/
      DATA CHALP/'abcdefghijklmnopqrstuvwxyz',
     &'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/, CHDIG/'1234567890'/
 
C...Length of character variable. Subdivide it into instructions.
      IF(MSTU(12).NE.12345.AND.CHIN.NE.'mstu(12)=12345'.AND.
     &CHIN.NE.'MSTU(12)=12345') CALL PYLIST(0)
      CHBIT=CHIN//' '
      LBIT=101
  100 LBIT=LBIT-1
      IF(CHBIT(LBIT:LBIT).EQ.' ') GOTO 100
      LTOT=0
      DO 110 LCOM=1,LBIT
        IF(CHBIT(LCOM:LCOM).EQ.' ') GOTO 110
        LTOT=LTOT+1
        CHFIX(LTOT:LTOT)=CHBIT(LCOM:LCOM)
  110 CONTINUE
      LLOW=0
  120 LHIG=LLOW+1
  130 LHIG=LHIG+1
      IF(LHIG.LE.LTOT.AND.CHFIX(LHIG:LHIG).NE.';') GOTO 130
      LBIT=LHIG-LLOW-1
      CHBIT(1:LBIT)=CHFIX(LLOW+1:LHIG-1)

C...Send off decay-mode on/off commands to PYONOF.
      IONOF=0
      DO 135 LDIG=1,10
        IF(CHBIT(1:1).EQ.CHDIG(LDIG:LDIG)) IONOF=1
  135 CONTINUE
      IF(IONOF.EQ.1) THEN
        CALL PYONOF(CHIN)
        RETURN
      ENDIF   
 
C...Peel off any text following exclamation mark.
      LHIG2=LBIT
      DO 140 LLOW2=LHIG2,1,-1
        IF(CHBIT(LLOW2:LLOW2).EQ.'!') LBIT=LLOW2-1
  140 CONTINUE
      IF(LBIT.EQ.0) RETURN
 
C...Identify commonblock variable.
      LNAM=1
  150 LNAM=LNAM+1
      IF(CHBIT(LNAM:LNAM).NE.'('.AND.CHBIT(LNAM:LNAM).NE.'='.AND.
     &LNAM.LE.6) GOTO 150
      CHNAM=CHBIT(1:LNAM-1)//' '
      DO 170 LCOM=1,LNAM-1
        DO 160 LALP=1,26
          IF(CHNAM(LCOM:LCOM).EQ.CHALP(1)(LALP:LALP)) CHNAM(LCOM:LCOM)=
     &    CHALP(2)(LALP:LALP)
  160   CONTINUE
  170 CONTINUE
      IVAR=0
      DO 180 IV=1,57
        IF(CHNAM.EQ.CHVAR(IV)) IVAR=IV
  180 CONTINUE
      IF(IVAR.EQ.0) THEN
        CALL PYERRM(18,'(PYGIVE:) do not recognize variable '//CHNAM)
        LLOW=LHIG
        IF(LLOW.LT.LTOT) GOTO 120
        RETURN
      ENDIF
 
C...Identify any indices.
      I1=0
      I2=0
      I3=0
      NINDX=0
      IF(CHBIT(LNAM:LNAM).EQ.'(') THEN
        LIND=LNAM
  190   LIND=LIND+1
        IF(CHBIT(LIND:LIND).NE.')'.AND.CHBIT(LIND:LIND).NE.',') GOTO 190
        CHIND=' '
        IF((CHBIT(LNAM+1:LNAM+1).EQ.'C'.OR.CHBIT(LNAM+1:LNAM+1).EQ.'c')
     &  .AND.(IVAR.EQ.9.OR.IVAR.EQ.10.OR.IVAR.EQ.13.OR.IVAR.EQ.17.OR.
     &  IVAR.EQ.37)) THEN
          CHIND(LNAM-LIND+11:8)=CHBIT(LNAM+2:LIND-1)
          READ(CHIND,'(I8)') KF
          I1=PYCOMP(KF)
        ELSEIF(CHBIT(LNAM+1:LNAM+1).EQ.'C'.OR.CHBIT(LNAM+1:LNAM+1).EQ.
     &    'c') THEN
          CALL PYERRM(18,'(PYGIVE:) not allowed to use C index for '//
     &    CHNAM)
          LLOW=LHIG
          IF(LLOW.LT.LTOT) GOTO 120
          RETURN
        ELSE
          CHIND(LNAM-LIND+10:8)=CHBIT(LNAM+1:LIND-1)
          READ(CHIND,'(I8)') I1
        ENDIF
        LNAM=LIND
        IF(CHBIT(LNAM:LNAM).EQ.')') LNAM=LNAM+1
        NINDX=1
      ENDIF
      IF(CHBIT(LNAM:LNAM).EQ.',') THEN
        LIND=LNAM
  200   LIND=LIND+1
        IF(CHBIT(LIND:LIND).NE.')'.AND.CHBIT(LIND:LIND).NE.',') GOTO 200
        CHIND=' '
        CHIND(LNAM-LIND+10:8)=CHBIT(LNAM+1:LIND-1)
        READ(CHIND,'(I8)') I2
        LNAM=LIND
        IF(CHBIT(LNAM:LNAM).EQ.')') LNAM=LNAM+1
        NINDX=2
      ENDIF
      IF(CHBIT(LNAM:LNAM).EQ.',') THEN
        LIND=LNAM
  210   LIND=LIND+1
        IF(CHBIT(LIND:LIND).NE.')'.AND.CHBIT(LIND:LIND).NE.',') GOTO 210
        CHIND=' '
        CHIND(LNAM-LIND+10:8)=CHBIT(LNAM+1:LIND-1)
        READ(CHIND,'(I8)') I3
        LNAM=LIND+1
        NINDX=3
      ENDIF
 
C...Check that indices allowed.
      IERR=0
      IF(NINDX.NE.MSVAR(IVAR,2)) IERR=1
      IF(NINDX.GE.1.AND.(I1.LT.MSVAR(IVAR,3).OR.I1.GT.MSVAR(IVAR,4)))
     &IERR=2
      IF(NINDX.GE.2.AND.(I2.LT.MSVAR(IVAR,5).OR.I2.GT.MSVAR(IVAR,6)))
     &IERR=3
      IF(NINDX.EQ.3.AND.(I3.LT.MSVAR(IVAR,7).OR.I3.GT.MSVAR(IVAR,8)))
     &IERR=4
      IF(CHBIT(LNAM:LNAM).NE.'=') IERR=5
      IF(IERR.GE.1) THEN
        CALL PYERRM(18,'(PYGIVE:) unallowed indices for '//
     &  CHBIT(1:LNAM-1))
        LLOW=LHIG
        IF(LLOW.LT.LTOT) GOTO 120
        RETURN
      ENDIF
 
C...Save old value of variable.
      IF(IVAR.EQ.1) THEN
        IOLD=N
      ELSEIF(IVAR.EQ.2) THEN
        IOLD=K(I1,I2)
      ELSEIF(IVAR.EQ.3) THEN
        ROLD=P(I1,I2)
      ELSEIF(IVAR.EQ.4) THEN
        ROLD=V(I1,I2)
      ELSEIF(IVAR.EQ.5) THEN
        IOLD=MSTU(I1)
      ELSEIF(IVAR.EQ.6) THEN
        ROLD=PARU(I1)
      ELSEIF(IVAR.EQ.7) THEN
        IOLD=MSTJ(I1)
      ELSEIF(IVAR.EQ.8) THEN
        ROLD=PARJ(I1)
      ELSEIF(IVAR.EQ.9) THEN
        IOLD=KCHG(I1,I2)
      ELSEIF(IVAR.EQ.10) THEN
        ROLD=PMAS(I1,I2)
      ELSEIF(IVAR.EQ.11) THEN
        ROLD=PARF(I1)
      ELSEIF(IVAR.EQ.12) THEN
        ROLD=VCKM(I1,I2)
      ELSEIF(IVAR.EQ.13) THEN
        IOLD=MDCY(I1,I2)
      ELSEIF(IVAR.EQ.14) THEN
        IOLD=MDME(I1,I2)
      ELSEIF(IVAR.EQ.15) THEN
        ROLD=BRAT(I1)
      ELSEIF(IVAR.EQ.16) THEN
        IOLD=KFDP(I1,I2)
      ELSEIF(IVAR.EQ.17) THEN
        CHOLD=CHAF(I1,I2)(1:8)
      ELSEIF(IVAR.EQ.18) THEN
        IOLD=MRPY(I1)
      ELSEIF(IVAR.EQ.19) THEN
        ROLD=RRPY(I1)
      ELSEIF(IVAR.EQ.20) THEN
        IOLD=MSEL
      ELSEIF(IVAR.EQ.21) THEN
        IOLD=MSUB(I1)
      ELSEIF(IVAR.EQ.22) THEN
        IOLD=KFIN(I1,I2)
      ELSEIF(IVAR.EQ.23) THEN
        ROLD=CKIN(I1)
      ELSEIF(IVAR.EQ.24) THEN
        IOLD=MSTP(I1)
      ELSEIF(IVAR.EQ.25) THEN
        ROLD=PARP(I1)
      ELSEIF(IVAR.EQ.26) THEN
        IOLD=MSTI(I1)
      ELSEIF(IVAR.EQ.27) THEN
        ROLD=PARI(I1)
      ELSEIF(IVAR.EQ.28) THEN
        IOLD=MINT(I1)
      ELSEIF(IVAR.EQ.29) THEN
        ROLD=VINT(I1)
      ELSEIF(IVAR.EQ.30) THEN
        IOLD=ISET(I1)
      ELSEIF(IVAR.EQ.31) THEN
        IOLD=KFPR(I1,I2)
      ELSEIF(IVAR.EQ.32) THEN
        ROLD=COEF(I1,I2)
      ELSEIF(IVAR.EQ.33) THEN
        IOLD=ICOL(I1,I2,I3)
      ELSEIF(IVAR.EQ.34) THEN
        ROLD=XSFX(I1,I2)
      ELSEIF(IVAR.EQ.35) THEN
        IOLD=ISIG(I1,I2)
      ELSEIF(IVAR.EQ.36) THEN
        ROLD=SIGH(I1)
      ELSEIF(IVAR.EQ.37) THEN
        IOLD=MWID(I1)
      ELSEIF(IVAR.EQ.38) THEN
        ROLD=WIDS(I1,I2)
      ELSEIF(IVAR.EQ.39) THEN
        IOLD=NGEN(I1,I2)
      ELSEIF(IVAR.EQ.40) THEN
        ROLD=XSEC(I1,I2)
      ELSEIF(IVAR.EQ.41) THEN
        CHOLD2=PROC(I1)
      ELSEIF(IVAR.EQ.42) THEN
        ROLD=SIGT(I1,I2,I3)
      ELSEIF(IVAR.EQ.43) THEN
        ROLD=XPVMD(I1)
      ELSEIF(IVAR.EQ.44) THEN
        ROLD=XPANL(I1)
      ELSEIF(IVAR.EQ.45) THEN
        ROLD=XPANH(I1)
      ELSEIF(IVAR.EQ.46) THEN
        ROLD=XPBEH(I1)
      ELSEIF(IVAR.EQ.47) THEN
        ROLD=XPDIR(I1)
      ELSEIF(IVAR.EQ.48) THEN
        IOLD=IMSS(I1)
      ELSEIF(IVAR.EQ.49) THEN
        ROLD=RMSS(I1)
      ELSEIF(IVAR.EQ.50) THEN
        ROLD=RVLAM(I1,I2,I3)
      ELSEIF(IVAR.EQ.51) THEN
        ROLD=RVLAMP(I1,I2,I3)
      ELSEIF(IVAR.EQ.52) THEN
        ROLD=RVLAMB(I1,I2,I3)
      ELSEIF(IVAR.EQ.53) THEN
        IOLD=ITCM(I1)
      ELSEIF(IVAR.EQ.54) THEN
        ROLD=RTCM(I1)
      ELSEIF(IVAR.EQ.55) THEN
        IOLD=IUED(I1)
      ELSEIF(IVAR.EQ.56) THEN
        ROLD=RUED(I1)
      ELSEIF(IVAR.EQ.57) THEN
        ROLD=GENPAR(I1)
      ENDIF
 
C...Print current value of variable. Loop back.
      IF(LNAM.GE.LBIT) THEN
        CHBIT(LNAM:14)=' '
        CHBIT(15:60)=' has the value                                '
        IF(MSVAR(IVAR,1).EQ.1) THEN
          WRITE(CHBIT(51:60),'(I10)') IOLD
        ELSEIF(MSVAR(IVAR,1).EQ.2) THEN
          WRITE(CHBIT(47:60),'(F14.5)') ROLD
        ELSEIF(MSVAR(IVAR,1).EQ.3) THEN
          CHBIT(53:60)=CHOLD
        ELSE
          CHBIT(33:60)=CHOLD
        ENDIF
        IF(MSTU(13).GE.1) WRITE(MSTU(11),5000) CHBIT(1:60)
        LLOW=LHIG
        IF(LLOW.LT.LTOT) GOTO 120
        RETURN
      ENDIF
 
C...Read in new variable value.
      IF(MSVAR(IVAR,1).EQ.1) THEN
        CHINI=' '
        CHINI(LNAM-LBIT+11:10)=CHBIT(LNAM+1:LBIT)
        READ(CHINI,'(I10)') INEW
      ELSEIF(MSVAR(IVAR,1).EQ.2) THEN
        CHINR=' '
        CHINR(LNAM-LBIT+17:16)=CHBIT(LNAM+1:LBIT)
        READ(CHINR,*) RNEW
      ELSEIF(MSVAR(IVAR,1).EQ.3) THEN
        CHNEW=CHBIT(LNAM+1:LBIT)//' '
      ELSE
        CHNEW2=CHBIT(LNAM+1:LBIT)//' '
      ENDIF
 
C...Store new variable value.
      IF(IVAR.EQ.1) THEN
        N=INEW
      ELSEIF(IVAR.EQ.2) THEN
        K(I1,I2)=INEW
      ELSEIF(IVAR.EQ.3) THEN
        P(I1,I2)=RNEW
      ELSEIF(IVAR.EQ.4) THEN
        V(I1,I2)=RNEW
      ELSEIF(IVAR.EQ.5) THEN
        MSTU(I1)=INEW
      ELSEIF(IVAR.EQ.6) THEN
        PARU(I1)=RNEW
      ELSEIF(IVAR.EQ.7) THEN
        MSTJ(I1)=INEW
      ELSEIF(IVAR.EQ.8) THEN
        PARJ(I1)=RNEW
      ELSEIF(IVAR.EQ.9) THEN
        KCHG(I1,I2)=INEW
      ELSEIF(IVAR.EQ.10) THEN
        PMAS(I1,I2)=RNEW
      ELSEIF(IVAR.EQ.11) THEN
        PARF(I1)=RNEW
      ELSEIF(IVAR.EQ.12) THEN
        VCKM(I1,I2)=RNEW
      ELSEIF(IVAR.EQ.13) THEN
        MDCY(I1,I2)=INEW
      ELSEIF(IVAR.EQ.14) THEN
        MDME(I1,I2)=INEW
      ELSEIF(IVAR.EQ.15) THEN
        BRAT(I1)=RNEW
      ELSEIF(IVAR.EQ.16) THEN
        KFDP(I1,I2)=INEW
      ELSEIF(IVAR.EQ.17) THEN
        CHAF(I1,I2)=CHNEW
      ELSEIF(IVAR.EQ.18) THEN
        MRPY(I1)=INEW
      ELSEIF(IVAR.EQ.19) THEN
        RRPY(I1)=RNEW
      ELSEIF(IVAR.EQ.20) THEN
        MSEL=INEW
      ELSEIF(IVAR.EQ.21) THEN
        MSUB(I1)=INEW
      ELSEIF(IVAR.EQ.22) THEN
        KFIN(I1,I2)=INEW
      ELSEIF(IVAR.EQ.23) THEN
        CKIN(I1)=RNEW
      ELSEIF(IVAR.EQ.24) THEN
        MSTP(I1)=INEW
      ELSEIF(IVAR.EQ.25) THEN
        PARP(I1)=RNEW
      ELSEIF(IVAR.EQ.26) THEN
        MSTI(I1)=INEW
      ELSEIF(IVAR.EQ.27) THEN
        PARI(I1)=RNEW
      ELSEIF(IVAR.EQ.28) THEN
        MINT(I1)=INEW
      ELSEIF(IVAR.EQ.29) THEN
        VINT(I1)=RNEW
      ELSEIF(IVAR.EQ.30) THEN
        ISET(I1)=INEW
      ELSEIF(IVAR.EQ.31) THEN
        KFPR(I1,I2)=INEW
      ELSEIF(IVAR.EQ.32) THEN
        COEF(I1,I2)=RNEW
      ELSEIF(IVAR.EQ.33) THEN
        ICOL(I1,I2,I3)=INEW
      ELSEIF(IVAR.EQ.34) THEN
        XSFX(I1,I2)=RNEW
      ELSEIF(IVAR.EQ.35) THEN
        ISIG(I1,I2)=INEW
      ELSEIF(IVAR.EQ.36) THEN
        SIGH(I1)=RNEW
      ELSEIF(IVAR.EQ.37) THEN
        MWID(I1)=INEW
      ELSEIF(IVAR.EQ.38) THEN
        WIDS(I1,I2)=RNEW
      ELSEIF(IVAR.EQ.39) THEN
        NGEN(I1,I2)=INEW
      ELSEIF(IVAR.EQ.40) THEN
        XSEC(I1,I2)=RNEW
      ELSEIF(IVAR.EQ.41) THEN
        PROC(I1)=CHNEW2
      ELSEIF(IVAR.EQ.42) THEN
        SIGT(I1,I2,I3)=RNEW
      ELSEIF(IVAR.EQ.43) THEN
        XPVMD(I1)=RNEW
      ELSEIF(IVAR.EQ.44) THEN
        XPANL(I1)=RNEW
      ELSEIF(IVAR.EQ.45) THEN
        XPANH(I1)=RNEW
      ELSEIF(IVAR.EQ.46) THEN
        XPBEH(I1)=RNEW
      ELSEIF(IVAR.EQ.47) THEN
        XPDIR(I1)=RNEW
      ELSEIF(IVAR.EQ.48) THEN
        IMSS(I1)=INEW
      ELSEIF(IVAR.EQ.49) THEN
        RMSS(I1)=RNEW
      ELSEIF(IVAR.EQ.50) THEN
        RVLAM(I1,I2,I3)=RNEW
      ELSEIF(IVAR.EQ.51) THEN
        RVLAMP(I1,I2,I3)=RNEW
      ELSEIF(IVAR.EQ.52) THEN
        RVLAMB(I1,I2,I3)=RNEW
      ELSEIF(IVAR.EQ.53) THEN
        ITCM(I1)=INEW
      ELSEIF(IVAR.EQ.54) THEN
        RTCM(I1)=RNEW
      ELSEIF(IVAR.EQ.55) THEN
        IUED(I1)=INEW
      ELSEIF(IVAR.EQ.56) THEN
        RUED(I1)=RNEW
      ELSEIF(IVAR.EQ.57) THEN
        GENPAR(I1)=RNEW
      ENDIF
 
C...Write old and new value. Loop back.
      CHBIT(LNAM:14)=' '
      CHBIT(15:60)=' changed from                to               '
      IF(MSVAR(IVAR,1).EQ.1) THEN
        WRITE(CHBIT(33:42),'(I10)') IOLD
        WRITE(CHBIT(51:60),'(I10)') INEW
        IF(MSTU(13).GE.1) WRITE(MSTU(11),5000) CHBIT(1:60)
      ELSEIF(MSVAR(IVAR,1).EQ.2) THEN
        WRITE(CHBIT(29:42),'(F14.5)') ROLD
        WRITE(CHBIT(47:60),'(F14.5)') RNEW
        IF(MSTU(13).GE.1) WRITE(MSTU(11),5000) CHBIT(1:60)
      ELSEIF(MSVAR(IVAR,1).EQ.3) THEN
        CHBIT(35:42)=CHOLD
        CHBIT(53:60)=CHNEW
        IF(MSTU(13).GE.1) WRITE(MSTU(11),5000) CHBIT(1:60)
      ELSE
        CHBIT(15:88)=' changed from '//CHOLD2//' to '//CHNEW2
        IF(MSTU(13).GE.1) WRITE(MSTU(11),5100) CHBIT(1:88)
      ENDIF
      LLOW=LHIG
      IF(LLOW.LT.LTOT) GOTO 120
 
C...Format statement for output on unit MSTU(11) (by default 6).
 5000 FORMAT(5X,A60)
 5100 FORMAT(5X,A88)
 
      RETURN
      END
c**************************************************************************
C...write event in the format needed for the
C...Les Houches event record. 
C...Save all stable particles only.
 
      SUBROUTINE MONCHER_PYUPEV_ST
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
      INTEGER PYK,PYCHGE,PYCOMP
 
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYCTAG/NCT,MCT(4000,2)
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      COMMON/PYDAT2/KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT1/MINT(400),VINT(400)
      COMMON/PYINT2/ISET(500),KFPR(500,2),COEF(500,20),ICOL(40,4,2)
      COMMON/PYINT4/MWID(500),WIDS(500,5)
      SAVE /PYJETS/,/PYCTAG/,/PYDAT1/,/PYDAT2/,/PYDAT3/,/PYPARS/,
     &/PYINT1/,/PYINT2/,/PYINT4/
 
C...HEPEUP for output.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)
      SAVE /HEPEUP/
c-...global MONCHER parameters
      INTEGER MXGLPAR      
      REAL GENPAR
      PARAMETER   (MXGLPAR=200)
      COMMON /MONCHERGLPAR/ GENPAR(MXGLPAR)
      
c IDWTUP = 3 requires XWGTUP = 1
      XWGTUP_wlhe = 1
      
  
C...Put event in HEPEUP commonblock.
      NUP=N
      IDPRUP=GENPAR(1)
      XWGTUP=1D0
      SCALUP=-1
      AQEDUP=-1
      AQCDUP=-1
      NUPS=0
      DO 180 I=1,NUP
       IF(K(I,1).EQ.1.OR.I.LE.2) THEN
        NUPS=NUPS+1
        IDUP(NUPS)=K(I,2)
        ISTUP(NUPS)=1
	IF(NUPS.LE.2) ISTUP(NUPS)=-1
	IF(NUPS.EQ.1.OR.NUPS.EQ.2) THEN
         MOTHUP(1,NUPS)=0
         MOTHUP(2,NUPS)=0
	ENDIF 
	IF(NUPS.GE.3) THEN
         MOTHUP(1,NUPS)=3
         MOTHUP(2,NUPS)=3
	ENDIF 
c        MOTHUP(1,NUPS)=0
c        MOTHUP(2,NUPS)=0
        ICOLUP(1,NUPS)=0
        ICOLUP(2,NUPS)=0
        DO 170 J=1,5
          PUP(J,NUPS)=P(I,J)
  170   CONTINUE
        VTIMUP(NUPS)=V(I,5)
        SPINUP(NUPS)=9D0
       ENDIF   	
  180 CONTINUE
      NUP=NUPS
  
C...Optionally write out event to disk. Minimal size for time/spin fields.
      IF(MSTP(162).GT.0) THEN
        WRITE(MSTP(162),5200) NUP,IDPRUP,XWGTUP_wlhe,SCALUP,AQEDUP
     +   ,AQCDUP
        DO 190 I=1,NUP
          IF(VTIMUP(I).EQ.0D0) THEN
            WRITE(MSTP(162),5300) IDUP(I),ISTUP(I),MOTHUP(1,I),
     &      MOTHUP(2,I),ICOLUP(1,I),ICOLUP(2,I),(PUP(J,I),J=1,5),
     &      ' 0. 9.'
          ELSE
            WRITE(MSTP(162),5400) IDUP(I),ISTUP(I),MOTHUP(1,I),
     &      MOTHUP(2,I),ICOLUP(1,I),ICOLUP(2,I),(PUP(J,I),J=1,5),
     &      VTIMUP(I),' 9.'
          ENDIF
  190   CONTINUE

C...Optional extra line with parton-density information.
        IF(MSTP(165).GE.1) WRITE(MSTP(162),5500) MSTI(15),MSTI(16),
     &  PARI(33),PARI(34),PARI(23),PARI(29),PARI(30) 
      ENDIF
 
C...Print formats.

 5200 FORMAT(1P,2I6,4E14.6)
 5300 FORMAT(1P,I8,5I5,5E18.10,A6)
 5400 FORMAT(1P,I8,5I5,5E18.10,E12.4,A3)
 5500 FORMAT(1P,'#pdf ',2I5,5E18.10)
 
      RETURN
      END
      
C*********************************************************************
 
C...Fills the HEPRUP commonblock with info on incoming beams and allowed
C...processes, and optionally stores that information on file.
 
      SUBROUTINE MONCHER_PYUPIN
 
C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      IMPLICIT INTEGER(I-N)
 
C...Commonblocks.
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)
      COMMON/PYINT5/NGENPD,NGEN(0:500,3),XSEC(0:500,3)
      SAVE /PYJETS/,/PYSUBS/,/PYPARS/,/PYINT5/
 
C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/
 
C...Store info on incoming beams.
      IDBMUP(1)=K(1,2)
      IDBMUP(2)=K(2,2)
      EBMUP(1)=P(1,4)
      EBMUP(2)=P(2,4)
c      PDFGUP(1)=0
c      PDFGUP(2)=0
c      PDFSUP(1)=MSTP(51)
c      PDFSUP(2)=MSTP(51)
      PDFGUP(1)=-9
      PDFGUP(2)=-9
      PDFSUP(1)=-9
      PDFSUP(2)=-9
 
C...Event weighting strategy.
      IDWTUP=3
 
C...Info on individual processes.
      NPRUP=0
      DO 100 ISUB=1,500
        IF(MSUB(ISUB).EQ.1) THEN
          NPRUP=NPRUP+1
          XSECUP(NPRUP)=1D9*XSEC(ISUB,3)
          XERRUP(NPRUP)=XSECUP(NPRUP)/SQRT(MAX(1D0,DBLE(NGEN(ISUB,3))))
          XMAXUP(NPRUP)=1D0
          LPRUP(NPRUP)=ISUB
        ENDIF
  100 CONTINUE
 
C...Write info to file.
      IF(MSTP(161).GT.0) THEN
        WRITE(MSTP(161),5100) IDBMUP(1),IDBMUP(2),EBMUP(1),EBMUP(2),
     &  PDFGUP(1),PDFGUP(2),PDFSUP(1),PDFSUP(2),IDWTUP,NPRUP
        DO 110 IPR=1,NPRUP
          WRITE(MSTP(161),5200) XSECUP(IPR),XERRUP(IPR),XMAXUP(IPR),
     &    LPRUP(IPR)
  110   CONTINUE
      ENDIF
 
C...Formats for printout.
 5100 FORMAT(1P,2I8,2E14.6,6I6)
 5200 FORMAT(1P,3E14.6,I6)
 
      RETURN
      END      
c-====================================================
c subroutines for MonCHER 1.0.0  R.Ryutin
c-====================================================
c--- final momenta for CE ------------------------------------
c--- 4-momenta of n and R+=pi,rho,a2 -> NO=1,2,3 -------------
c- PN(1),PN(2)-transverse, PN(3)-longitudinal, PN(4)-energy
c- PR(1),PR(2)-transverse, PR(3)-longitudinal, PR(4)-energy
       SUBROUTINE CEMOM(NO,PN,PR,M2)
       
       IMPLICIT NONE
       EXTERNAL NTAB
c--------- general parameters ------------------------ 
      DOUBLE PRECISION XSQ,PI,MPI,MP,MN,MRHO,MA2
      DOUBLE PRECISION XIMIN,XIMAX,QTMIN,QTMAX
      DOUBLE PRECISION API,ARHO,AA2,R2PI,R2RHO,R2A2
      DOUBLE PRECISION GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION S
      INTEGER NMODPP,NMODRR,ITYPR
      COMMON/PNTAB0/S,NMODPP,NMODRR,ITYPR
      COMMON/PNTAB1/XSQ(6),PI,MPI,MP,MN,MRHO,MA2
      COMMON/PNTAB2/XIMIN,XIMAX,QTMIN,QTMAX
      COMMON/PNTAB3/API,ARHO,AA2,R2PI,R2RHO,R2A2
      COMMON/PNTAB4/GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
c--------- tables for absorbtion and form-factors ----
      DOUBLE PRECISION SSPI,SSRHO,SSA2,SDPIS,SDPIA,
     & SDRHOS,SDRHOA,SDA2S,SDA2A,FFDPI,FFDRHO,FFDA2     
      DOUBLE PRECISION XSSPI,XSSRHO,XSSA2,XSDPIS,XSDPIA,
     & XSDRHOS,XSDRHOA,XSDA2S,XSDA2A,XFFDPI,XFFDRHO,XFFDA2
      DOUBLE PRECISION SPI,SRHO,SA2,DPI,DRHO,DA2,
     & FDPI,FDRHO,FDA2     
      DOUBLE PRECISION SPIX1,SPIX2,SPIXQ,SROX1,SROX2,SROXQ,
     & SA2X1,SA2X2,SA2XQ,DPIX1,DPIX2,DPIXX,
     & DROX1,DROX2,DROXX,DA2X1,DA2X2,DA2XX,
     & DDPI1,DDPI2,DDPI3,DDRO1,DDRO2,DDRO3,
     & DDA21,DDA22,DDA23
      COMMON/CEDATGET/SSPI(6,53,41),SSRHO(6,53,51),
     & SSA2(6,53,51),SDPIS(6,10,8,9,8),SDPIA(6,10,8,9,8),
     & SDRHOS(6,10,8,9,8),SDRHOA(6,10,8,9,8),SDA2S(6,10,8,9,8),     
     & SDA2A(6,10,8,9,8),FFDPI(6,60,16),FFDRHO(6,60,16),
     & FFDA2(6,60,16)     
      COMMON/CEDATFIX/XSSPI(53,41),XSSRHO(53,51),
     & XSSA2(53,51),XSDPIS(10,8,9,8),XSDPIA(10,8,9,8),
     & XSDRHOS(10,8,9,8),XSDRHOA(10,8,9,8),XSDA2S(10,8,9,8),     
     & XSDA2A(10,8,9,8),XFFDPI(60,16),XFFDRHO(60,16),
     & XFFDA2(60,16)
      COMMON/CEDATMOD/SPI(41,41),SRHO(41,41),SA2(41,41),
     & DPI(17,17,17,17),DRHO(17,17,17,17),DA2(17,17,17,17),
     & FDPI(17,17),FDRHO(17,17),FDA2(17,17)
      COMMON/CEDATGEN/SPIX1(41),SPIX2(41),SPIXQ(2,41,41),
     & SROX1(41),SROX2(41),SROXQ(2,41,41),
     & SA2X1(41),SA2X2(41),SA2XQ(2,41,41),
     & DPIX1(17),DPIX2(17),DPIXX(2,17,17),
     & DROX1(17),DROX2(17),DROXX(2,17,17),
     & DA2X1(17),DA2X2(17),DA2XX(2,17,17),
     & DDPI1(4,17,17,17),DDPI2(4,17,17,17),DDPI3(8,17,17,17,17),
     & DDRO1(4,17,17,17),DDRO2(4,17,17,17),DDRO3(8,17,17,17,17),
     & DDA21(4,17,17,17),DDA22(4,17,17,17),DDA23(8,17,17,17,17)
c- arrays for variables
      DOUBLE PRECISION VXIR,VFIS,VFIA,VQTR,
     & VXIRF,VFIF,VXI,VQT,SVXI,SVQT,DVXI,DVQT 
      COMMON/CEDATVARS/VXIR(10),VFIS(8),VFIA(8),VQTR(9),
     & VXIRF(60),VFIF(16),VXI(53),VQT(41),
     & SVXI(41),SVQT(41),DVXI(17),DVQT(17) 
       
       INTEGER NO,IG(2)
       DOUBLE PRECISION PYR,XIG,QTG,T,M2,XR,XN,PHI,PT
       DOUBLE PRECISION AUX1,AUX2,AUX3,AUX4,BEP,XG(2),RG(2)
       DOUBLE PRECISION PN(5),PR(5)        
 
       RG(1)=PYR(0)
       RG(2)=PYR(0)
       IF (NO.EQ.1.OR.NO.GE.4) THEN
       CALL GENT2D(SPI,SVXI,SVQT,41,41,
     & SPIX1,SPIX2,SPIXQ,RG,XG,IG)
       ENDIF
       IF (NO.EQ.2) THEN
       CALL GENT2D(SRHO,SVXI,SVQT,41,41,
     & SROX1,SROX2,SROXQ,RG,XG,IG)       
       ENDIF
       IF (NO.EQ.3) THEN
       CALL GENT2D(SA2,SVXI,SVQT,41,41,
     & SA2X1,SA2X2,SA2XQ,RG,XG,IG)       
       ENDIF
       XIG=XG(1)
       QTG=XG(2)

       BEP=DSQRT(1.D0-4.D0*MP*MP/S) 
c----- |-t| ------------
       AUX1=XIG*BEP*MP
       AUX2=MN*MN-MP*MP
       AUX3=XIG*BEP*BEP
       AUX4=QTG*QTG+AUX1*AUX1+AUX2*(AUX3-AUX2/S)
       T=AUX4/(1.D0-AUX3+2.D0*AUX2/S)
c---- M**2 -------------
       M2=S*BEP*BEP*XIG+MN*MN-2.D0*(T+AUX2)
c------ xi -------------
       XR=XIG
c-- mom. fraction of neutron --------       
       XN=1.D0-XR
c-- azymuthal angle 
       PHI=PYR(0)*2.D0*PI
c-- transverse momenta abs. value.
       PT=QTG
c- mass       
       PN(5)=MN
c- (-T) is the momentum squared of pi-meson
       PR(5)=-DSQRT(T)
c- transverse
       PR(1)=PT*DCOS(PHI)
       PR(2)=PT*DSIN(PHI)
       PN(1)=-PR(1)
       PN(2)=-PR(2)
c- longitudinal
       PN(3)=XN*SQRT(S/4.D0-MP*MP)
       PR(3)=XR*SQRT(S/4.D0-MP*MP)       
c- energy
       PN(4)=DSQRT(PN(5)**2+PT**2+PN(3)**2)
       PR(4)=DSQRT(-PR(5)**2+PT**2+PR(3)**2)
      
       RETURN
       END

c--- final momenta for DCE -----------------------------------
c--- ONLY pi<->R reshuffling with probability=0.5
c--- in the final event (for R=pi -> no reshuffling!)
c--- i.e. pi(1)+R(2) or R(1)+pi(2)!
c--- only processes p+p->n1+(pi+R->X)+n2 ---------------------
c--- 4-momenta of n1,n2,R1,R2, 
c--- R1,R2=pi,rho,a2 or pi-> NO=1,2,3
c- P(1),P(2)-transverse, P(3)-longitudinal, P(4)-energy
c- P= PN1,PN2 (reshuffling prob=0.5)<-> PR1,PR2
       SUBROUTINE DCEMOM(NO,PN1,PN2,PR1,PR2,M2)
       
       IMPLICIT NONE
       EXTERNAL NTAB
c--------- general parameters ------------------------ 
      DOUBLE PRECISION XSQ,PI,MPI,MP,MN,MRHO,MA2
      DOUBLE PRECISION XIMIN,XIMAX,QTMIN,QTMAX
      DOUBLE PRECISION API,ARHO,AA2,R2PI,R2RHO,R2A2
      DOUBLE PRECISION GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION S
      INTEGER NMODPP,NMODRR,ITYPR
      COMMON/PNTAB0/S,NMODPP,NMODRR,ITYPR
      COMMON/PNTAB1/XSQ(6),PI,MPI,MP,MN,MRHO,MA2
      COMMON/PNTAB2/XIMIN,XIMAX,QTMIN,QTMAX
      COMMON/PNTAB3/API,ARHO,AA2,R2PI,R2RHO,R2A2
      COMMON/PNTAB4/GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
c--------- tables for absorbtion and form-factors ----
      DOUBLE PRECISION SSPI,SSRHO,SSA2,SDPIS,SDPIA,
     & SDRHOS,SDRHOA,SDA2S,SDA2A,FFDPI,FFDRHO,FFDA2     
      DOUBLE PRECISION XSSPI,XSSRHO,XSSA2,XSDPIS,XSDPIA,
     & XSDRHOS,XSDRHOA,XSDA2S,XSDA2A,XFFDPI,XFFDRHO,XFFDA2
      DOUBLE PRECISION SPI,SRHO,SA2,DPI,DRHO,DA2,
     & FDPI,FDRHO,FDA2     
      DOUBLE PRECISION SPIX1,SPIX2,SPIXQ,SROX1,SROX2,SROXQ,
     & SA2X1,SA2X2,SA2XQ,DPIX1,DPIX2,DPIXX,
     & DROX1,DROX2,DROXX,DA2X1,DA2X2,DA2XX,
     & DDPI1,DDPI2,DDPI3,DDRO1,DDRO2,DDRO3,
     & DDA21,DDA22,DDA23
      COMMON/CEDATGET/SSPI(6,53,41),SSRHO(6,53,51),
     & SSA2(6,53,51),SDPIS(6,10,8,9,8),SDPIA(6,10,8,9,8),
     & SDRHOS(6,10,8,9,8),SDRHOA(6,10,8,9,8),SDA2S(6,10,8,9,8),     
     & SDA2A(6,10,8,9,8),FFDPI(6,60,16),FFDRHO(6,60,16),
     & FFDA2(6,60,16)     
      COMMON/CEDATFIX/XSSPI(53,41),XSSRHO(53,51),
     & XSSA2(53,51),XSDPIS(10,8,9,8),XSDPIA(10,8,9,8),
     & XSDRHOS(10,8,9,8),XSDRHOA(10,8,9,8),XSDA2S(10,8,9,8),     
     & XSDA2A(10,8,9,8),XFFDPI(60,16),XFFDRHO(60,16),
     & XFFDA2(60,16)
      COMMON/CEDATMOD/SPI(41,41),SRHO(41,41),SA2(41,41),
     & DPI(17,17,17,17),DRHO(17,17,17,17),DA2(17,17,17,17),
     & FDPI(17,17),FDRHO(17,17),FDA2(17,17)
      COMMON/CEDATGEN/SPIX1(41),SPIX2(41),SPIXQ(2,41,41),
     & SROX1(41),SROX2(41),SROXQ(2,41,41),
     & SA2X1(41),SA2X2(41),SA2XQ(2,41,41),
     & DPIX1(17),DPIX2(17),DPIXX(2,17,17),
     & DROX1(17),DROX2(17),DROXX(2,17,17),
     & DA2X1(17),DA2X2(17),DA2XX(2,17,17),
     & DDPI1(4,17,17,17),DDPI2(4,17,17,17),DDPI3(8,17,17,17,17),
     & DDRO1(4,17,17,17),DDRO2(4,17,17,17),DDRO3(8,17,17,17,17),
     & DDA21(4,17,17,17),DDA22(4,17,17,17),DDA23(8,17,17,17,17)
c- arrays for variables
      DOUBLE PRECISION VXIR,VFIS,VFIA,VQTR,
     & VXIRF,VFIF,VXI,VQT,SVXI,SVQT,DVXI,DVQT 
      COMMON/CEDATVARS/VXIR(10),VFIS(8),VFIA(8),VQTR(9),
     & VXIRF(60),VFIF(16),VXI(53),VQT(41),
     & SVXI(41),SVQT(41),DVXI(17),DVQT(17) 
       
       INTEGER NO,IG(2),I
       DOUBLE PRECISION PYR,XIG1,QTG1,T1,XIG2,QTG2,T2,XIG(2)
       DOUBLE PRECISION M2,XR,XN,PHI,PT
       DOUBLE PRECISION AUX1,AUX2,AUX3,AUX4,BEP,XG(2),RG(2)
       DOUBLE PRECISION PN1(5),PN2(5),PR1(5),PR2(5),PAU        

c-- xi1,xi2 generation 
       RG(1)=PYR(0)
       RG(2)=PYR(0)       
       IF (NO.EQ.1.OR.NO.GE.4) THEN
       CALL GENT2D(FDPI,DVXI,DVXI,17,17,
     & DPIX1,DPIX2,DPIXX,RG,XG,IG)       
       ENDIF
       IF (NO.EQ.2) THEN
       CALL GENT2D(FDRHO,DVXI,DVXI,17,17,
     & DROX1,DROX2,DROXX,RG,XG,IG)        
       ENDIF
       IF (NO.EQ.3) THEN
       CALL GENT2D(FDA2,DVXI,DVXI,17,17,
     & DA2X1,DA2X2,DA2XX,RG,XG,IG)        
       ENDIF
       XIG1=XG(1)
       XIG(1)=XG(1)
       XIG2=XG(2)
       XIG(2)=XG(2)
c-- qt1,qt2 generation at fixed generated xi1,xi2
       RG(1)=PYR(0)
       RG(2)=PYR(0)       
       IF (NO.EQ.1.OR.NO.GE.4) THEN
       CALL GENT2D4(DPI,DVXI,DVQT,17,17,
     & DDPI1,DDPI2,DDPI3,IG,XIG,RG,XG)       
       ENDIF
       IF (NO.EQ.2) THEN
       CALL GENT2D4(DRHO,DVXI,DVQT,17,17,
     & DDRO1,DDRO2,DDRO3,IG,XIG,RG,XG)       
       ENDIF
       IF (NO.EQ.3) THEN
       CALL GENT2D4(DA2,DVXI,DVQT,17,17,
     & DDA21,DDA22,DDA23,IG,XIG,RG,XG)       
       ENDIF
       QTG1=XG(1)
       QTG2=XG(2)
c-- momenta-1
       BEP=DSQRT(1.D0-4.D0*MP*MP/S) 
c----- |-t| ------------
       AUX1=XIG1*BEP*MP
       AUX2=MN*MN-MP*MP
       AUX3=XIG1*BEP*BEP
       AUX4=QTG1*QTG1+AUX1*AUX1+AUX2*(AUX3-AUX2/S)
       T1=AUX4/(1.D0-AUX3+2.D0*AUX2/S)
c------ xi -------------
       XR=XIG1
c-- mom. fraction of neutron --------       
       XN=1.D0-XR
c-- azymuthal angle 
       PHI=PYR(0)*2.D0*PI
c-- transverse momenta abs. value.
       PT=QTG1
c- mass       
       PN1(5)=MN
c- (-T) is the momentum squared of pi-meson
       PR1(5)=-DSQRT(T1)
c- transverse
       PR1(1)=PT*DCOS(PHI)
       PR1(2)=PT*DSIN(PHI)
       PN1(1)=-PR1(1)
       PN1(2)=-PR1(2)
c- longitudinal
       PN1(3)=XN*SQRT(S/4.D0-MP*MP)
       PR1(3)=XR*SQRT(S/4.D0-MP*MP)       
c- energy
       PN1(4)=DSQRT(PN1(5)**2+PT**2+PN1(3)**2)
       PR1(4)=DSQRT(-PR1(5)**2+PT**2+PR1(3)**2)

c-- momenta-2
c----- |-t| ------------
       AUX1=XIG2*BEP*MP
       AUX2=MN*MN-MP*MP
       AUX3=XIG2*BEP*BEP
       AUX4=QTG2*QTG2+AUX1*AUX1+AUX2*(AUX3-AUX2/S)
       T2=AUX4/(1.D0-AUX3+2.D0*AUX2/S)
c------ xi -------------
       XR=XIG2
c-- mom. fraction of neutron --------       
       XN=1.D0-XR
c-- azymuthal angle 
       PHI=PYR(0)*2.D0*PI
c-- transverse momenta abs. value.
       PT=QTG2
c- mass       
       PN2(5)=MN
c- (-T) is the momentum squared of pi-meson
       PR2(5)=-DSQRT(T2)
c- transverse
       PR2(1)=PT*DCOS(PHI)
       PR2(2)=PT*DSIN(PHI)
       PN2(1)=-PR2(1)
       PN2(2)=-PR2(2)
c- longitudinal
       PN2(3)=-XN*SQRT(S/4.D0-MP*MP)
       PR2(3)=-XR*SQRT(S/4.D0-MP*MP)       
c- energy
       PN2(4)=DSQRT(PN2(5)**2+PT**2+PN2(3)**2)
       PR2(4)=DSQRT(-PR2(5)**2+PT**2+PR2(3)**2)
c---- M**2 -------------
       M2=(PR1(4)+PR2(4))**2-(PR1(3)+PR2(3))**2
       M2=M2-(PR1(2)+PR2(2))**2-(PR1(1)+PR2(1))**2
      
       IF (NO.GT.1.AND.NO.LT.4) THEN
        IF (PYR(0).GT.0.5D0) THEN
         DO I=1,5
          PAU=PN1(I)
          PN1(I)=PN2(I)
          PN2(I)=PAU
          PAU=PR1(I)
          PR1(I)=PR2(I)
          PR2(I)=PAU
         ENDDO
        ENDIF 
       ENDIF
      
       RETURN
       END

c---------- 2D generation from tables ------------------------
      SUBROUTINE GENT2D(FF,X1,X2,N1,N2,FF1,FF2,FF3,RG,XG,IG)
      
      IMPLICIT NONE
      INTEGER N1,N2,IN1G,IN2G,I,IG(2)
      DOUBLE PRECISION FF(N1,N2),FF1(N1),FF2(N1)
      DOUBLE PRECISION FF3(2,N1,N2)
      DOUBLE PRECISION DX1,DX2,X1(N1),X2(N2),XG(2),RG(2)
      DOUBLE PRECISION FG(2),AU1,AU2,UG1,AU3,AU4

       FG(1)=FF2(N1)*RG(1)
       I=1
 13    I=I+1   
       IF (FG(1).GT.FF2(I)) GOTO 13
       IN1G=I-1
       DX1=X1(IN1G+1)-X1(IN1G)
       IF (FF1(IN1G+1).NE.FF1(IN1G)) THEN        
        AU1=(FF1(IN1G+1)-FF1(IN1G))/DX1
        AU2=DSQRT(FF1(IN1G)**2+2.D0*AU1*(FG(1)-FF2(IN1G)))
        XG(1)=X1(IN1G)+(AU2-FF1(IN1G))/AU1
       ELSE
        IF (FF1(IN1G).EQ.0.D0) THEN
         XG(1)=X1(IN1G)+RG(1)*DX1
        ELSE
         XG(1)=X1(IN1G)+(FG(1)-FF2(IN1G))/FF1(IN1G)
        ENDIF
       ENDIF
       UG1=(XG(1)-X1(IN1G))/DX1
       
       FG(2)=(FF3(1,IN1G,N2)+UG1*FF3(2,IN1G,N2))*RG(2)
       I=1
 14    I=I+1
       IF (FG(2).GT.(FF3(1,IN1G,I)+UG1*FF3(2,IN1G,I))) GOTO 14
       IN2G=I-1
       DX2=X2(IN2G+1)-X2(IN2G)
       AU3=FF(IN1G,IN2G)+UG1*(FF(IN1G+1,IN2G)-FF(IN1G,IN2G))
       AU4=FF(IN1G,IN2G+1)
       AU4=AU4+UG1*(FF(IN1G+1,IN2G+1)-FF(IN1G,IN2G+1))
       AU4=AU4-AU3
       IF (AU4.NE.0.D0) THEN        
        AU1=FG(2)-FF3(1,IN1G,IN2G)-UG1*FF3(2,IN1G,IN2G)
        AU2=DSQRT(AU3**2+2.D0*AU4*AU1/DX2)
        XG(2)=X2(IN2G)+(AU2-AU3)*DX2/AU4
       ELSE
        IF (AU3.EQ.0.D0) THEN
         XG(2)=X2(IN2G)+RG(2)*DX2
        ELSE
         AU1=FG(2)-FF3(1,IN1G,IN2G)-UG1*FF3(2,IN1G,IN2G)
         XG(2)=X2(IN2G)+AU1/AU3
        ENDIF
       ENDIF       
       
       IG(1)=IN1G
       IG(2)=IN2G

       RETURN
       END
c---------- 4D symmetric generation from tables --------------
      SUBROUTINE GENT2D4(FF,X1,X2,N1,N2,FF1,FF2,FF3,II,XX,RG,XG)
      
      IMPLICIT NONE
      INTEGER N1,N2,IN1G,IN2G,II(2),I3,I4,I
      DOUBLE PRECISION FF(N1,N1,N2,N2),XX(2),
     & FF1(4,N1,N1,N2),FF2(4,N1,N1,N2),FF3(8,N1,N1,N2,N2)
      DOUBLE PRECISION DX1,DX2,X1(N1),X2(N2),XG(2),RG(2)
      DOUBLE PRECISION FG(2),UG3,UG4,UG1,AU1,AU2,AU3,AU4

c- II(1),II(2) are first numbers in all multidim. arrays <N1
       I3=II(1)
       I4=II(2)
       UG3=(XX(1)-X1(I3))/(X1(I3+1)-X1(I3))
       UG4=(XX(2)-X1(I4))/(X1(I4+1)-X1(I4))

       AU1=FF2(1,I3,I4,N2)+UG3*FF2(2,I3,I4,N2)
       AU1=AU1+FF2(3,I3,I4,N2)*UG4+FF2(4,I3,I4,N2)*UG3*UG4
       FG(1)=AU1*RG(1)
       I=1
 15    I=I+1
       AU1=FF2(1,I3,I4,I)+UG3*FF2(2,I3,I4,I)
       AU1=AU1+FF2(3,I3,I4,I)*UG4+FF2(4,I3,I4,I)*UG3*UG4       
       IF (FG(1).GT.AU1) GOTO 15
       IN1G=I-1
       DX1=X2(IN1G+1)-X2(IN1G)
       AU3=FF1(1,I3,I4,IN1G)+UG3*FF1(2,I3,I4,IN1G)
       AU3=AU3+FF1(3,I3,I4,IN1G)*UG4+FF1(4,I3,I4,IN1G)*UG3*UG4
       AU4=FF1(1,I3,I4,IN1G+1)+UG3*FF1(2,I3,I4,IN1G+1)
       AU4=AU4+FF1(3,I3,I4,IN1G+1)*UG4
       AU4=AU4+FF1(4,I3,I4,IN1G+1)*UG3*UG4-AU3
       IF (AU4.NE.0D0) THEN        
        AU1=FG(1)-FF2(1,I3,I4,IN1G)-UG3*FF2(2,I3,I4,IN1G)
        AU1=AU1-UG4*FF2(3,I3,I4,IN1G)-UG3*UG4*FF2(4,I3,I4,IN1G)
        AU2=DSQRT(AU3**2+2.D0*AU1*AU4/DX1)
        XG(1)=X2(IN1G)+(AU2-AU3)*DX1/AU4
       ELSE
        IF (AU3.EQ.0.D0) THEN
         XG(1)=X2(IN1G)+RG(1)*DX1
        ELSE
        AU1=FG(1)-FF2(1,I3,I4,IN1G)-UG3*FF2(2,I3,I4,IN1G)
        AU1=AU1-UG4*FF2(3,I3,I4,IN1G)-UG3*UG4*FF2(4,I3,I4,IN1G)        
         XG(1)=X2(IN1G)+AU1/AU3
        ENDIF
       ENDIF
       UG1=(XG(1)-X2(IN1G))/DX1
       
       AU1=FF3(1,I3,I4,IN1G,N2)+UG1*FF3(5,I3,I4,IN1G,N2)
       AU2=FF3(2,I3,I4,IN1G,N2)+UG1*FF3(6,I3,I4,IN1G,N2)
       AU1=AU1+UG3*AU2
       AU2=FF3(3,I3,I4,IN1G,N2)+UG1*FF3(7,I3,I4,IN1G,N2)
       AU1=AU1+UG4*AU2
       AU2=FF3(4,I3,I4,IN1G,N2)+UG1*FF3(8,I3,I4,IN1G,N2)
       AU1=AU1+UG3*UG4*AU2       
       FG(2)=AU1*RG(2)

       I=1
 16    I=I+1
       AU1=FF3(1,I3,I4,IN1G,I)+UG1*FF3(5,I3,I4,IN1G,I)
       AU2=FF3(2,I3,I4,IN1G,I)+UG1*FF3(6,I3,I4,IN1G,I)
       AU1=AU1+UG3*AU2
       AU2=FF3(3,I3,I4,IN1G,I)+UG1*FF3(7,I3,I4,IN1G,I)
       AU1=AU1+UG4*AU2
       AU2=FF3(4,I3,I4,IN1G,I)+UG1*FF3(8,I3,I4,IN1G,I)
       AU1=AU1+UG3*UG4*AU2

       IF (FG(2).GT.AU1) GOTO 16
       IN2G=I-1
       DX2=X2(IN2G+1)-X2(IN2G)

c-
       AU1=FF(I3,I4,IN1G,IN2G)*(1.D0-UG3-UG4+UG3*UG4)
       AU1=AU1+FF(I3+1,I4,IN1G,IN2G)*UG3*(1.D0-UG4)
       AU1=AU1+FF(I3,I4+1,IN1G,IN2G)*UG4*(1.D0-UG3)
       AU1=AU1+FF(I3+1,I4+1,IN1G,IN2G)*UG3*UG4
       AU2=FF(I3,I4,IN1G+1,IN2G)*(1.D0-UG3-UG4+UG3*UG4)
       AU2=AU2+FF(I3+1,I4,IN1G+1,IN2G)*UG3*(1.D0-UG4)
       AU2=AU2+FF(I3,I4+1,IN1G+1,IN2G)*UG4*(1.D0-UG3)
       AU2=AU2+FF(I3+1,I4+1,IN1G+1,IN2G)*UG3*UG4       
       AU3=AU1+UG1*(AU2-AU1)
c-
       AU1=FF(I3,I4,IN1G,IN2G+1)*(1.D0-UG3-UG4+UG3*UG4)
       AU1=AU1+FF(I3+1,I4,IN1G,IN2G+1)*UG3*(1.D0-UG4)
       AU1=AU1+FF(I3,I4+1,IN1G,IN2G+1)*UG4*(1.D0-UG3)
       AU1=AU1+FF(I3+1,I4+1,IN1G,IN2G+1)*UG3*UG4
       AU2=FF(I3,I4,IN1G+1,IN2G+1)*(1.D0-UG3-UG4+UG3*UG4)
       AU2=AU2+FF(I3+1,I4,IN1G+1,IN2G+1)*UG3*(1.D0-UG4)
       AU2=AU2+FF(I3,I4+1,IN1G+1,IN2G+1)*UG4*(1.D0-UG3)
       AU2=AU2+FF(I3+1,I4+1,IN1G+1,IN2G+1)*UG3*UG4       
       AU4=AU1+UG1*(AU2-AU1)-AU3

c-
       IF (AU4.NE.0.D0) THEN
        AU1=FF3(1,I3,I4,IN1G,IN2G)+UG1*FF3(5,I3,I4,IN1G,IN2G)
        AU2=FF3(2,I3,I4,IN1G,IN2G)+UG1*FF3(6,I3,I4,IN1G,IN2G)
        AU1=AU1+UG3*AU2
        AU2=FF3(3,I3,I4,IN1G,IN2G)+UG1*FF3(7,I3,I4,IN1G,IN2G)
        AU1=AU1+UG4*AU2
        AU2=FF3(4,I3,I4,IN1G,IN2G)+UG1*FF3(8,I3,I4,IN1G,IN2G)
        AU1=AU1+UG3*UG4*AU2               
        AU1=FG(2)-AU1
        AU2=DSQRT(AU3**2+2.D0*AU4*AU1/DX2)
        XG(2)=X2(IN2G)+(AU2-AU3)*DX2/AU4
       ELSE
        IF (AU3.EQ.0.D0) THEN
         XG(2)=X2(IN2G)+RG(2)*DX2
        ELSE
         AU1=FF3(1,I3,I4,IN1G,IN2G)+UG1*FF3(5,I3,I4,IN1G,IN2G)
         AU2=FF3(2,I3,I4,IN1G,IN2G)+UG1*FF3(6,I3,I4,IN1G,IN2G)
         AU1=AU1+UG3*AU2
         AU2=FF3(3,I3,I4,IN1G,IN2G)+UG1*FF3(7,I3,I4,IN1G,IN2G)
         AU1=AU1+UG4*AU2
         AU2=FF3(4,I3,I4,IN1G,IN2G)+UG1*FF3(8,I3,I4,IN1G,IN2G)
         AU1=AU1+UG3*UG4*AU2               
         AU1=FG(2)-AU1
         XG(2)=X2(IN2G)+AU1/AU3
        ENDIF
       ENDIF       

       RETURN
       END




c------ bare cross-sections for CE and DCE
c-- CE bare cross-sections dsig/dqt dxi
c--- NO=1: SpiE, NO=2: SrhoE, NO=3: Sa2E
       FUNCTION DCSCE0(NO,XI,QT)

      IMPLICIT NONE
      EXTERNAL NTAB
      INTEGER NO
      DOUBLE PRECISION DCSCE0,SIGTOTRP,XI,QT
c--------- general parameters ------------------------ 
      DOUBLE PRECISION XSQ,PI,MPI,MP,MN,MRHO,MA2
      DOUBLE PRECISION XIMIN,XIMAX,QTMIN,QTMAX
      DOUBLE PRECISION API,ARHO,AA2,R2PI,R2RHO,R2A2
      DOUBLE PRECISION GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION S
      INTEGER NMODPP,NMODRR,ITYPR
      COMMON/PNTAB0/S,NMODPP,NMODRR,ITYPR
      COMMON/PNTAB1/XSQ(6),PI,MPI,MP,MN,MRHO,MA2
      COMMON/PNTAB2/XIMIN,XIMAX,QTMIN,QTMAX
      COMMON/PNTAB3/API,ARHO,AA2,R2PI,R2RHO,R2A2
      COMMON/PNTAB4/GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2  
       
      DOUBLE PRECISION BET2,EPS2,AUFXI,AUFQ 
C- NO=1: SpiE
       IF (NO.EQ.1) THEN
        BET2=(R2PI-API*DLOG(XI))/(1.D0-XI)
        EPS2=MP*MP*XI*XI+MPI*MPI*(1.D0-XI)
        AUFXI=GPI*XI*0.5D0/PI
        AUFXI=AUFXI*XI**(2.D0*API*EPS2/(1.D0-XI))
        AUFXI=AUFXI*DEXP(-2.D0*R2PI*MP*MP*XI*XI/(1.D0-XI))
        AUFQ=1.D0/(QT**2+EPS2)**2.D0
        AUFQ=AUFQ+(0.5D0*PI*API/(1.D0-XI))**2.D0
        AUFQ=AUFQ*(QT*QT+XI*XI*MP*MP)*DEXP(-2.D0*BET2*QT*QT)
        DCSCE0=AUFXI*AUFQ 
       ENDIF
C- NO=2: SrhoE
       IF (NO.EQ.2) THEN
        BET2=(R2RHO-ARHO*DLOG(XI))/(1.D0-XI)
        EPS2=MP*MP*XI*XI
        AUFXI=GRHO*0.5D0/PI/(1.D0-XI)
        AUFXI=AUFXI*XI**(2.D0*ARHO*EPS2/(1.D0-XI))
        AUFXI=AUFXI*DEXP(-2.D0*R2RHO*MP*MP*XI*XI/(1.D0-XI))
        AUFQ=1.D0+(KARHO*QT*0.5D0/MP)**2.D0
        AUFQ=AUFQ*DEXP(-2.D0*BET2*QT*QT)        
        DCSCE0=SIGRSQ*AUFXI*AUFQ  
       ENDIF       
C- NO=3: Sa2E
       IF (NO.EQ.3) THEN
        BET2=(R2A2-AA2*DLOG(XI))/(1.D0-XI)
        EPS2=MP*MP*XI*XI
        AUFXI=GA2*0.5D0/PI/(1.D0-XI)
        AUFXI=AUFXI*XI**(2.D0*AA2*EPS2/(1.D0-XI))
        AUFXI=AUFXI*DEXP(-2.D0*R2A2*MP*MP*XI*XI/(1.D0-XI))
        AUFQ=1.D0+(KAA2*QT*0.5D0/MP)**2.D0
        AUFQ=AUFQ*DEXP(-2.D0*BET2*QT*QT)        
        DCSCE0=SIGRSQ*AUFXI*AUFQ  
       ENDIF
       
       DCSCE0=DCSCE0*2.D0*QT*SIGTOTRP(NO,NMODRR,XI*S)
       
       RETURN
       END

c-- DCE bare cross-sections dsigma/dqt1 dqt2 dxi1 dxi2
c--- NO=1: DpiE, NO=2: DrhopiE, NO=3: Da2piE
       FUNCTION DCSDCE0(NO,XI1,XI2,QT1,QT2)

      IMPLICIT NONE
      EXTERNAL NTAB
      INTEGER NO
      DOUBLE PRECISION DCSDCE0,DCSCE0,SIGTOTRP,SIGTOTRR
      DOUBLE PRECISION XI1,XI2,QT1,QT2
c--------- general parameters ------------------------ 
      DOUBLE PRECISION XSQ,PI,MPI,MP,MN,MRHO,MA2
      DOUBLE PRECISION XIMIN,XIMAX,QTMIN,QTMAX
      DOUBLE PRECISION API,ARHO,AA2,R2PI,R2RHO,R2A2
      DOUBLE PRECISION GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION S
      INTEGER NMODPP,NMODRR,ITYPR
      COMMON/PNTAB0/S,NMODPP,NMODRR,ITYPR
      COMMON/PNTAB1/XSQ(6),PI,MPI,MP,MN,MRHO,MA2
      COMMON/PNTAB2/XIMIN,XIMAX,QTMIN,QTMAX
      COMMON/PNTAB3/API,ARHO,AA2,R2PI,R2RHO,R2A2
      COMMON/PNTAB4/GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2           
       
      DOUBLE PRECISION BET2,EPS2,AUFXI1,AUFQ1,AUFXI2,AUFQ2
      DOUBLE PRECISION AU1,AU2,AU3,AUFPI1,AUFPI2 
C- NO=1: DpiE
       IF (NO.EQ.1) THEN        
        DCSDCE0=DCSCE0(1,XI1,QT1)*DCSCE0(1,XI2,QT2)
        DCSDCE0=DCSDCE0/SIGTOTRP(1,NMODRR,XI1*S)
        DCSDCE0=DCSDCE0/SIGTOTRP(1,NMODRR,XI2*S)
       ENDIF
C- NO=2: DrhopiE
       IF (NO.EQ.2) THEN
        AU1=DCSCE0(1,XI1,QT1)*DCSCE0(2,XI2,QT2)
        AU1=AU1/SIGTOTRP(1,NMODRR,XI1*S)
        AU1=AU1/SIGTOTRP(2,NMODRR,XI2*S)       
        AU2=DCSCE0(2,XI1,QT1)*DCSCE0(1,XI2,QT2)
	AU2=AU2/SIGTOTRP(2,NMODRR,XI1*S)
        AU2=AU2/SIGTOTRP(1,NMODRR,XI2*S)
c-- interference part
c-- rho part        
        BET2=(R2RHO-ARHO*DLOG(XI1))/(1.D0-XI1)
        EPS2=MP*MP*XI1*XI1
        AUFXI1=XI1**(ARHO*EPS2/(1.D0-XI1))/DSQRT(1.D0-XI1)
        AUFXI1=AUFXI1*DEXP(-R2RHO*MP*MP*XI1*XI1/(1.D0-XI1))        
        AUFQ1=DEXP(-BET2*QT1*QT1)
        AUFQ1=AUFQ1*(MP*XI1+QT1*QT1*KARHO*0.5D0/MP)
        BET2=(R2RHO-ARHO*DLOG(XI2))/(1.D0-XI2)
        EPS2=MP*MP*XI2*XI2
        AUFXI2=XI2**(ARHO*EPS2/(1.D0-XI2))/DSQRT(1.D0-XI2)
        AUFXI2=AUFXI2*DEXP(-R2RHO*MP*MP*XI2*XI2/(1.D0-XI2))
        AUFQ2=DEXP(-BET2*QT2*QT2)        
        AUFQ2=AUFQ2*(MP*XI2+QT2*QT2*KARHO*0.5D0/MP)
        AU3=AUFXI1*AUFQ1*AUFXI2*AUFQ2*GRHO*0.5D0/PI
        AU3=AU3*SIGRSQ
c-- pi part        
        BET2=(R2PI-API*DLOG(XI1))/(1.D0-XI1)
        EPS2=MP*MP*XI1*XI1+MPI*MPI*(1.D0-XI1)
        AUFXI1=XI1**(API*EPS2/(1.D0-XI1))
        AUFXI1=AUFXI1*DEXP(-R2PI*MP*MP*XI1*XI1/(1.D0-XI1))
        AUFQ1=1.D0/(QT1**2+EPS2)
        AUFQ1=AUFQ1*DEXP(-BET2*QT1*QT1)        
        AUFPI1=0.5D0*PI*API*DEXP(-BET2*QT1*QT1)/(1.D0-XI1)        
        BET2=(R2PI-API*DLOG(XI2))/(1.D0-XI2)
        EPS2=MP*MP*XI2*XI2+MPI*MPI*(1.D0-XI2)
        AUFXI2=XI2**(API*EPS2/(1.D0-XI2))
        AUFXI2=AUFXI2*DEXP(-R2PI*MP*MP*XI2*XI2/(1.D0-XI2))
        AUFQ2=1.D0/(QT2**2+EPS2)
        AUFQ2=AUFQ2*DEXP(-BET2*QT2*QT2)        
        AUFPI2=0.5D0*PI*API*DEXP(-BET2*QT2*QT2)/(1.D0-XI2)        
        AU3=AU3*AUFXI1*AUFXI2*(AUFQ1*AUFQ2+AUFPI1*AUFPI2)        
        AU3=AU3*2.D0*GPI*DSQRT(XI1*XI2)*0.5D0/PI
        DCSDCE0=AU1+AU2+4.D0*QT1*QT2*AU3  
       ENDIF       
C- NO=3: Da2piE
       IF (NO.EQ.3) THEN
        AU1=DCSCE0(1,XI1,QT1)*DCSCE0(3,XI2,QT2)
        AU1=AU1/SIGTOTRP(1,NMODRR,XI1*S)
        AU1=AU1/SIGTOTRP(3,NMODRR,XI2*S)       
        AU2=DCSCE0(3,XI1,QT1)*DCSCE0(1,XI2,QT2)
	AU2=AU2/SIGTOTRP(3,NMODRR,XI1*S)
        AU2=AU2/SIGTOTRP(1,NMODRR,XI2*S)
c-- interference part
c-- rho part        
        BET2=(R2A2-AA2*DLOG(XI1))/(1.D0-XI1)
        EPS2=MP*MP*XI1*XI1
        AUFXI1=XI1**(AA2*EPS2/(1.D0-XI1))/DSQRT(1.D0-XI1)
        AUFXI1=AUFXI1*DEXP(-R2A2*MP*MP*XI1*XI1/(1.D0-XI1))        
        AUFQ1=DEXP(-BET2*QT1*QT1)
        AUFQ1=AUFQ1*(MP*XI1+QT1*QT1*KAA2*0.5D0/MP)
        BET2=(R2A2-AA2*DLOG(XI2))/(1.D0-XI2)
        EPS2=MP*MP*XI2*XI2
        AUFXI2=XI2**(AA2*EPS2/(1.D0-XI2))/DSQRT(1.D0-XI2)
        AUFXI2=AUFXI2*DEXP(-R2A2*MP*MP*XI2*XI2/(1.D0-XI2))
        AUFQ2=DEXP(-BET2*QT2*QT2)        
        AUFQ2=AUFQ2*(MP*XI2+QT2*QT2*KAA2*0.5D0/MP)
        AU3=AUFXI1*AUFQ1*AUFXI2*AUFQ2*GA2*0.5D0/PI
        AU3=AU3*SIGRSQ
c-- pi part        
        BET2=(R2PI-API*DLOG(XI1))/(1.D0-XI1)
        EPS2=MP*MP*XI1*XI1+MPI*MPI*(1.D0-XI1)
        AUFXI1=XI1**(API*EPS2/(1.D0-XI1))
        AUFXI1=AUFXI1*DEXP(-R2PI*MP*MP*XI1*XI1/(1.D0-XI1))
        AUFQ1=1.D0/(QT1**2+EPS2)
        AUFQ1=AUFQ1*DEXP(-BET2*QT1*QT1)        
        AUFPI1=0.5D0*PI*API*DEXP(-BET2*QT1*QT1)/(1.D0-XI1)        
        BET2=(R2PI-API*DLOG(XI2))/(1.D0-XI2)
        EPS2=MP*MP*XI2*XI2+MPI*MPI*(1.D0-XI2)
        AUFXI2=XI2**(API*EPS2/(1.D0-XI2))
        AUFXI2=AUFXI2*DEXP(-R2PI*MP*MP*XI2*XI2/(1.D0-XI2))
        AUFQ2=1.D0/(QT2**2+EPS2)
        AUFQ2=AUFQ2*DEXP(-BET2*QT2*QT2)        
        AUFPI2=0.5D0*PI*API*DEXP(-BET2*QT2*QT2)/(1.D0-XI2)        
        AU3=AU3*AUFXI1*AUFXI2*(AUFQ1*AUFQ2+AUFPI1*AUFPI2)        
        AU3=AU3*2.D0*GPI*DSQRT(XI1*XI2)*0.5D0/PI
        DCSDCE0=AU1+AU2+4.D0*QT1*QT2*AU3
       ENDIF
       
       DCSDCE0=DCSDCE0*SIGTOTRR(NO,NMODRR,XI1*XI2*S)
       
       RETURN
       END              

c-- total RP and Rpi cross-sections in mb: R=pi,rho,a2
c-- NO=1,2,3 for pi,rho,a2.
c-- NCSMOD=1:DL, 2:COMPETE, 3:BSW, 4:GP
c-- RP cross-sections
       FUNCTION SIGTOTRP(NO,NCSMOD,SVAR)

      IMPLICIT NONE
      EXTERNAL NTAB
      INTEGER NO,NCSMOD
      DOUBLE PRECISION SIGTOTRP,SVAR     

       IF (NO.EQ.1) THEN
        IF (NCSMOD.EQ.1) THEN
         SIGTOTRP=13.63D0*SVAR**0.0808D0
         SIGTOTRP=SIGTOTRP+27.56D0*SVAR**(-0.4525D0)        
        ENDIF
        IF (NCSMOD.EQ.2) THEN
         SIGTOTRP=21.23D0+0.3152D0*DLOG(SVAR/34.D0)**2.D0
         SIGTOTRP=SIGTOTRP+17.8D0*SVAR**(-0.467D0)
         SIGTOTRP=SIGTOTRP-5.72D0*SVAR**(-0.5398D0)
        ENDIF
        IF (NCSMOD.EQ.3) THEN         
         SIGTOTRP=0.537838D-01*DLOG(DSQRT(SVAR)/9.D0)**1.79D0
         SIGTOTRP=1.D0+SIGTOTRP
         SIGTOTRP=SIGTOTRP*0.224322D+02
        ENDIF
        IF (NCSMOD.EQ.4) THEN
         SIGTOTRP=0.629629D-01*DLOG(DSQRT(SVAR)/9.D0)**1.84D0
         SIGTOTRP=1.D0+SIGTOTRP
         SIGTOTRP=SIGTOTRP*0.225991D+02        
        ENDIF       
       ENDIF

       IF (NO.EQ.2) THEN
        IF (NCSMOD.EQ.1) THEN
         SIGTOTRP=13.63D0*SVAR**0.0808D0
         SIGTOTRP=SIGTOTRP+27.56D0*SVAR**(-0.4525D0)        
        ENDIF
        IF (NCSMOD.EQ.2) THEN
         SIGTOTRP=21.23D0+0.3152D0*DLOG(SVAR/34.D0)**2.D0
         SIGTOTRP=SIGTOTRP+17.8D0*SVAR**(-0.467D0)
         SIGTOTRP=SIGTOTRP-5.72D0*SVAR**(-0.5398D0)
        ENDIF
        IF (NCSMOD.EQ.3) THEN         
         SIGTOTRP=0.537838D-01*DLOG(DSQRT(SVAR)/9.D0)**1.79D0
         SIGTOTRP=1.D0+SIGTOTRP
         SIGTOTRP=SIGTOTRP*0.224322D+02
        ENDIF
        IF (NCSMOD.EQ.4) THEN
         SIGTOTRP=0.629629D-01*DLOG(DSQRT(SVAR)/9.D0)**1.84D0
         SIGTOTRP=1.D0+SIGTOTRP
         SIGTOTRP=SIGTOTRP*0.225991D+02        
        ENDIF      
       ENDIF

       IF (NO.EQ.3) THEN
        IF (NCSMOD.EQ.1) THEN
         SIGTOTRP=13.63D0*SVAR**0.0808D0
         SIGTOTRP=SIGTOTRP+27.56D0*SVAR**(-0.4525D0)        
        ENDIF
        IF (NCSMOD.EQ.2) THEN
         SIGTOTRP=21.23D0+0.3152D0*DLOG(SVAR/34.D0)**2.D0
         SIGTOTRP=SIGTOTRP+17.8D0*SVAR**(-0.467D0)
         SIGTOTRP=SIGTOTRP-5.72D0*SVAR**(-0.5398D0)
        ENDIF
        IF (NCSMOD.EQ.3) THEN         
         SIGTOTRP=0.537838D-01*DLOG(DSQRT(SVAR)/9.D0)**1.79D0
         SIGTOTRP=1.D0+SIGTOTRP
         SIGTOTRP=SIGTOTRP*0.224322D+02
        ENDIF
        IF (NCSMOD.EQ.4) THEN
         SIGTOTRP=0.629629D-01*DLOG(DSQRT(SVAR)/9.D0)**1.84D0
         SIGTOTRP=1.D0+SIGTOTRP
         SIGTOTRP=SIGTOTRP*0.225991D+02        
        ENDIF      
       ENDIF
       
       RETURN
       END
       
c-- Rpi cross-sections
       FUNCTION SIGTOTRR(NO,NCSMOD,SVAR)

      IMPLICIT NONE
      EXTERNAL NTAB
      INTEGER NO,NCSMOD
      DOUBLE PRECISION SIGTOTRP,SIGTOTRR,SVAR,AU1       

       IF (NO.EQ.1) THEN
        IF (NCSMOD.EQ.1) THEN         
         AU1=21.7D0*SVAR**0.0808D0+56.08D0/SVAR**0.4525D0
         SIGTOTRR=SIGTOTRP(1,NCSMOD,SVAR)**2/AU1
        ENDIF
        IF (NCSMOD.EQ.2) THEN
         AU1=35.83D0+0.3152D0*DLOG(SVAR/34.D0)**2.D0
         AU1=AU1+42.1D0*SVAR**(-0.467D0)
         AU1=AU1-32.19D0*SVAR**(-0.5398D0)
         SIGTOTRR=SIGTOTRP(1,NCSMOD,SVAR)**2/AU1
        ENDIF
        IF (NCSMOD.EQ.3) THEN                  
         SIGTOTRR=0.738095D0*DLOG(DSQRT(SVAR)/9.D0)**1.8D0
         SIGTOTRR=SIGTOTRR+13.7252D0
        ENDIF
        IF (NCSMOD.EQ.4) THEN
         SIGTOTRR=0.81555D0*DLOG(DSQRT(SVAR)/500.D0)
         SIGTOTRR=SIGTOTRR*DLOG(DSQRT(SVAR)/500.D0)
         SIGTOTRR=SIGTOTRR+5.52046D0*DLOG(DSQRT(SVAR)/500.D0)
         SIGTOTRR=SIGTOTRR+26.4786D0        
        ENDIF       
       ENDIF

       IF (NO.EQ.2) THEN
        IF (NCSMOD.EQ.1) THEN         
         AU1=21.7D0*SVAR**0.0808D0+56.08D0/SVAR**0.4525D0
         SIGTOTRR=SIGTOTRP(1,NCSMOD,SVAR)**2/AU1
        ENDIF
        IF (NCSMOD.EQ.2) THEN
         AU1=35.83D0+0.3152D0*DLOG(SVAR/34.D0)**2.D0
         AU1=AU1+42.1D0*SVAR**(-0.467D0)
         AU1=AU1-32.19D0*SVAR**(-0.5398D0)
         SIGTOTRR=SIGTOTRP(1,NCSMOD,SVAR)**2/AU1
        ENDIF
        IF (NCSMOD.EQ.3) THEN                  
         SIGTOTRR=0.738095D0*DLOG(DSQRT(SVAR)/9.D0)**1.8D0
         SIGTOTRR=SIGTOTRR+13.7252D0
        ENDIF
        IF (NCSMOD.EQ.4) THEN
         SIGTOTRR=0.81555D0*DLOG(DSQRT(SVAR)/500.D0)
         SIGTOTRR=SIGTOTRR*DLOG(DSQRT(SVAR)/500.D0)
         SIGTOTRR=SIGTOTRR+5.52046D0*DLOG(DSQRT(SVAR)/500.D0)
         SIGTOTRR=SIGTOTRR+26.4786D0        
        ENDIF    
       ENDIF

       IF (NO.EQ.3) THEN
        IF (NCSMOD.EQ.1) THEN         
         AU1=21.7D0*SVAR**0.0808D0+56.08D0/SVAR**0.4525D0
         SIGTOTRR=SIGTOTRP(1,NCSMOD,SVAR)**2/AU1
        ENDIF
        IF (NCSMOD.EQ.2) THEN
         AU1=35.83D0+0.3152D0*DLOG(SVAR/34.D0)**2.D0
         AU1=AU1+42.1D0*SVAR**(-0.467D0)
         AU1=AU1-32.19D0*SVAR**(-0.5398D0)
         SIGTOTRR=SIGTOTRP(1,NCSMOD,SVAR)**2/AU1
        ENDIF
        IF (NCSMOD.EQ.3) THEN                  
         SIGTOTRR=0.738095D0*DLOG(DSQRT(SVAR)/9.D0)**1.8D0
         SIGTOTRR=SIGTOTRR+13.7252D0
        ENDIF
        IF (NCSMOD.EQ.4) THEN
         SIGTOTRR=0.81555D0*DLOG(DSQRT(SVAR)/500.D0)
         SIGTOTRR=SIGTOTRR*DLOG(DSQRT(SVAR)/500.D0)
         SIGTOTRR=SIGTOTRR+5.52046D0*DLOG(DSQRT(SVAR)/500.D0)
         SIGTOTRR=SIGTOTRR+26.4786D0        
        ENDIF   
       ENDIF
       
       RETURN
       END       
c------------- INTERPOLATION by several methods --------------
c-- CUBIC Interpolation in Log(S) variable --
       SUBROUTINE CUBINTLNSQ(FF,VS,FUN)
       
       IMPLICIT NONE
       INTEGER I,N
       DOUBLE PRECISION FF(6),DFF(6),DDFF(6),RR(6)
       DOUBLE PRECISION VS,VV,VFUN(5),FUN,AU1,AU2,AU3,AU4
       DOUBLE PRECISION AU5,AU6,AU7,AU8,AU9,AU10 
       DOUBLE PRECISION BS(6),CS(6),DS(6),HH(6),XX(6)
c--------- general parameters ------------------------ 
      DOUBLE PRECISION XSQ,PI,MPI,MP,MN,MRHO,MA2
      COMMON/PNTAB1/XSQ(6),PI,MPI,MP,MN,MRHO,MA2

      VV=DLOG(DSQRT(VS))      
      DO I=1,6
       XX(I)=DLOG(XSQ(I))
      ENDDO 
      DO I=1,5  
       HH(I)=XX(I+1)-XX(I)
       DFF(I)=(FF(I+1)-FF(I))/HH(I)
      ENDDO 
      DO I=1,4 
       DDFF(I)=(DFF(I+1)-DFF(I))/HH(I)
       RR(I)=HH(I+1)/HH(I)
      ENDDO 
      CS(1)=0.D0
      CS(6)=0.D0
      AU1=6.D0+6.D0*RR(3)+6.D0*RR(4)+8.D0*RR(3)*RR(4)
      AU2=8.D0+AU1*RR(2)+6.D0*RR(3)+8.D0*RR(4)+8.D0*RR(3)*RR(4)
      AU3=RR(2)*(DDFF(4)*RR(3)-2.D0*DDFF(3)*(1.D0+RR(4)))
      AU4=4.D0+3.D0*RR(3)+4.D0*(1.D0+RR(3))*RR(4)
      AU5=3.D0*(AU2*DDFF(1)-(AU3+AU4*DDFF(2))*RR(1))
      AU6=3.D0*RR(1)*(4.D0+3.D0*RR(3)+4.D0*RR(2)*(1+RR(3)))
      AU7=3.D0+3.D0*RR(2)+3.D0*RR(3)+4.D0*RR(2)*RR(3)
      AU7=AU7*4.D0*RR(1)*RR(4)
      AU8=4.D0+AU1*RR(2)/2.D0+3.D0*RR(3)+4.D0*(1.D0+RR(3))*RR(4)
      AU9=AU6+AU7+4.D0*AU8
      CS(2)=AU5/AU9
      AU1=-DDFF(1)*(4.D0+3.D0*RR(3)+4.D0*(1.D0+RR(3))*RR(4))
      AU2=4.D0+3.D0*RR(3)+4.D0*(1.D0+RR(3))*RR(4)
      AU3=DDFF(4)*RR(3)-2.D0*DDFF(3)*(1.D0+RR(4))
      AU4=AU2*DDFF(2)+AU3*RR(2)
      AU5=3.D0*(AU1+2.D0*AU4*(1.D0+RR(1)))
      AU6=4.D0+3.D0*RR(3)+4.D0*RR(2)*(1.D0+RR(3))
      AU7=3.D0+3.D0*RR(2)+3.D0*RR(3)+4.D0*RR(2)*RR(3)
      AU8=3.D0+3.D0*RR(3)+3.D0*RR(4)+4.D0*RR(3)*RR(4)
      AU9=4.D0+AU8*RR(2)+3.D0*RR(3)+4.D0*(1.D0+RR(3))*RR(4)
      AU10=4.D0*AU9+3.D0*AU6*RR(1)+4.D0*AU7*RR(1)*RR(4)
      CS(3)=AU5/AU10
      AU1=2.D0*DDFF(3)*(1.D0+RR(4))-DDFF(4)*RR(3)
      AU2=4.D0+3.D0*RR(1)+4.D0*(1.D0+RR(1))*RR(2)
      AU3=2.D0*DDFF(1)*(1.D0+RR(4))
      AU3=AU3-4.D0*DDFF(2)*(1.D0+RR(1))*(1.D0+RR(4))
      AU4=3.D0*(AU3+AU2*AU1)
      AU5=4.D0+3.D0*RR(3)+4.D0*RR(2)*(1.D0+RR(3))
      AU6=3.D0+3.D0*RR(2)+3.D0*RR(3)+4.D0*RR(2)*RR(3)
      AU7=3.D0+3.D0*RR(3)+3.D0*RR(4)+4.D0*RR(3)*RR(4)
      AU8=4.D0+AU7*RR(2)+3.D0*RR(3)+4.D0*(1.D0+RR(3))*RR(4)
      AU9=4.D0*AU8+3.D0*AU5*RR(1)+4.D0*AU6*RR(1)*RR(4)
      CS(4)=AU4/AU9
      AU1=4.D0+3.D0*RR(1)+4.D0*(1.D0+RR(1))*RR(2)
      AU2=RR(1)+RR(2)+RR(1)*RR(2)
      AU3=8.D0*DDFF(4)+2.D0*DDFF(2)*(1.D0+RR(1))-DDFF(1)
      AU3=AU3-AU1*DDFF(3)+6.D0*AU2*DDFF(4)
      AU3=AU3+2.D0*AU1*DDFF(4)*RR(3)
      AU3=AU3*3.D0
      AU4=4.D0+3.D0*RR(3)+4.D0*RR(2)*(1.D0+RR(3))
      AU5=3.D0+3.D0*RR(2)+3.D0*RR(3)+4.D0*RR(2)*RR(3)
      AU6=3.D0+3.D0*RR(3)+3.D0*RR(4)+4.D0*RR(3)*RR(4)
      AU7=4.D0+AU6*RR(2)+3.D0*RR(3)+4.D0*(1.D0+RR(3))*RR(4)
      AU8=4.D0*AU7+3.D0*AU4*RR(1)+4.D0*AU5*RR(1)*RR(4)
      CS(5)=AU3/AU8
      DO I=1,5
       DS(I)=(CS(I+1)-CS(I))/3.D0/HH(I)
       BS(I)=DFF(I)-HH(I)*(CS(I+1)+2.D0*CS(I))/3.D0
       IF (VV.GE.XX(I).AND.VV.LE.XX(I+1)) THEN
       FUN=(DS(I)*(VV-XX(I))+CS(I))*(VV-XX(I))+BS(I)
       FUN=FUN*(VV-XX(I))+FF(I)
       ENDIF
      ENDDO 

      IF (VV.LT.XX(1)) THEN
      FUN=(DS(1)*(VV-XX(1))+CS(1))*(VV-XX(1))+BS(1)
      FUN=FUN*(VV-XX(1))+FF(1)
      ENDIF
      IF (VV.GT.XX(6)) THEN
      FUN=(DS(5)*(VV-XX(5))+CS(5))*(VV-XX(5))+BS(5)
      FUN=FUN*(VV-XX(5))+FF(5)
      ENDIF
            
       RETURN
       END
c- UNIFORM MESH       
c- Linear interpolation 1-D
       SUBROUTINE ULININT1D(FUNDAT,N,X0,DX,XV,FUN)
       
       IMPLICIT NONE
       INTEGER N,I
       DOUBLE PRECISION FUNDAT(N),X0,DX,XV,FUN,UV,UX
       
c- I.LE.N-1, N points, N-1 intervals       
       UX=(XV-X0)/DX 
       I=DINT(UX)+1
       UV=UX-I+1
       FUN=FUNDAT(I)+(FUNDAT(I+1)-FUNDAT(I))*UV
              
       RETURN
       END

c- Linear interpolation 2-D
       SUBROUTINE ULININT2D(FDT,N1,N2,X0,DX,XV,FUN)
       
       IMPLICIT NONE
       INTEGER N1,N2,I1,I2
       DOUBLE PRECISION FDT(N1,N2),X0(2),DX(2),XV(2)
       DOUBLE PRECISION FUN,UV(2),UX(2)
       
c- Ix.LE.Nx-1, Nx points, Nx-1 intervals, x=1,2
       UX(1)=(XV(1)-X0(1))/DX(1)
       UX(2)=(XV(2)-X0(2))/DX(2)
       I1=DINT(UX(1))+1
       UV(1)=UX(1)-I1+1
       I2=DINT(UX(2))+1
       UV(2)=UX(2)-I2+1
       
       FUN=FDT(I1+1,I2+1)+FDT(I1,I2)-FDT(I1+1,I2)-FDT(I1,I2+1)
       FUN=FUN*UV(1)+FDT(I1,I2+1)-FDT(I1,I2)
       FUN=FUN*UV(2)+FDT(I1,I2)+(FDT(I1+1,I2)-FDT(I1,I2))*UV(1)
              
       RETURN
       END

c- Linear interpolation 3-D
       SUBROUTINE ULININT3D(FDT,N1,N2,N3,X0,DX,XV,FUN)
       
       IMPLICIT NONE
       INTEGER N1,N2,N3,I1,I2,I3,I
       DOUBLE PRECISION FDT(N1,N2,N3),X0(3),DX(3),XV(3)
       DOUBLE PRECISION FUN,UV(3),UX(3),F1,F2
       
c- Ix.LE.Nx-1, Nx points, Nx-1 intervals, x=1,3
       DO I=1,3  
       UX(I)=(XV(I)-X0(I))/DX(I)
       ENDDO
       I1=DINT(UX(1))+1
       UV(1)=UX(1)-I1+1
       I2=DINT(UX(2))+1
       UV(2)=UX(2)-I2+1
       I3=DINT(UX(3))+1
       UV(3)=UX(3)-I3+1
       
       F1=FDT(I1+1,I2+1,I3)+FDT(I1,I2,I3)
       F1=F1-FDT(I1+1,I2,I3)-FDT(I1,I2+1,I3)
       F1=F1*UV(1)+FDT(I1,I2+1,I3)-FDT(I1,I2,I3)
       F1=F1*UV(2)+FDT(I1,I2,I3)
       F1=F1+(FDT(I1+1,I2,I3)-FDT(I1,I2,I3))*UV(1)
       
       F2=FDT(I1+1,I2+1,I3+1)+FDT(I1,I2,I3+1)
       F2=F2-FDT(I1+1,I2,I3+1)-FDT(I1,I2+1,I3+1)
       F2=F2*UV(1)+FDT(I1,I2+1,I3+1)-FDT(I1,I2,I3+1)
       F2=F2*UV(2)+FDT(I1,I2,I3+1)
       F2=F2+(FDT(I1+1,I2,I3+1)-FDT(I1,I2,I3+1))*UV(1)
       
       FUN=F1+UV(3)*(F2-F1)
              
       RETURN
       END

c- Linear interpolation 4-D
       SUBROUTINE ULININT4D(FDT,N1,N2,N3,N4,X0,DX,XV,FUN)
       
       IMPLICIT NONE
       INTEGER N1,N2,N3,N4,I1,I2,I3,I4,I
       DOUBLE PRECISION FDT(N1,N2,N3,N4),X0(4),DX(4),XV(4)
       DOUBLE PRECISION FUN,UV(4),UX(4),F1,F2,FF1,FF2
       
c- Ix.LE.Nx-1, Nx points, Nx-1 intervals, x=1,4
       DO I=1,4
       UX(I)=(XV(I)-X0(I))/DX(I)
       ENDDO
       I1=DINT(UX(1))+1
       UV(1)=UX(1)-I1+1
       I2=DINT(UX(2))+1
       UV(2)=UX(2)-I2+1
       I3=DINT(UX(3))+1
       UV(3)=UX(3)-I3+1
       I4=DINT(UX(4))+1
       UV(4)=UX(4)-I4+1
       
       F1=FDT(I1+1,I2+1,I3,I4)+FDT(I1,I2,I3,I4)
       F1=F1-FDT(I1+1,I2,I3,I4)-FDT(I1,I2+1,I3,I4)
       F1=F1*UV(1)+FDT(I1,I2+1,I3,I4)-FDT(I1,I2,I3,I4)
       F1=F1*UV(2)+FDT(I1,I2,I3,I4)
       F1=F1+(FDT(I1+1,I2,I3,I4)-FDT(I1,I2,I3,I4))*UV(1)
       
       F2=FDT(I1+1,I2+1,I3+1,I4)+FDT(I1,I2,I3+1,I4)
       F2=F2-FDT(I1+1,I2,I3+1,I4)-FDT(I1,I2+1,I3+1,I4)
       F2=F2*UV(1)+FDT(I1,I2+1,I3+1,I4)-FDT(I1,I2,I3+1,I4)
       F2=F2*UV(2)+FDT(I1,I2,I3+1,I4)
       F2=F2+(FDT(I1+1,I2,I3+1,I4)-FDT(I1,I2,I3+1,I4))*UV(1)
       
       FF1=F1+UV(3)*(F2-F1)

       F1=FDT(I1+1,I2+1,I3,I4+1)+FDT(I1,I2,I3,I4+1)
       F1=F1-FDT(I1+1,I2,I3,I4+1)-FDT(I1,I2+1,I3,I4+1)
       F1=F1*UV(1)+FDT(I1,I2+1,I3,I4+1)-FDT(I1,I2,I3,I4+1)
       F1=F1*UV(2)+FDT(I1,I2,I3,I4+1)
       F1=F1+(FDT(I1+1,I2,I3,I4+1)-FDT(I1,I2,I3,I4+1))*UV(1)
       
       F2=FDT(I1+1,I2+1,I3+1,I4+1)+FDT(I1,I2,I3+1,I4+1)
       F2=F2-FDT(I1+1,I2,I3+1,I4+1)-FDT(I1,I2+1,I3+1,I4+1)
       F2=F2*UV(1)+FDT(I1,I2+1,I3+1,I4+1)-FDT(I1,I2,I3+1,I4+1)
       F2=F2*UV(2)+FDT(I1,I2,I3+1,I4+1)
       F2=F2+(FDT(I1+1,I2,I3+1,I4+1)-FDT(I1,I2,I3+1,I4+1))*UV(1)
       
       FF2=F1+UV(3)*(F2-F1)
       
       FUN=FF1+UV(4)*(FF2-FF1)
          
       RETURN
       END

c- Linear interpolation for any mesh
c- Linear interpolation 2-D
       SUBROUTINE LININT2D(FDT,X1,X2,N1,N2,XV,FUN)
       
       IMPLICIT NONE
       INTEGER N1,N2,I1,I2,I
       DOUBLE PRECISION FDT(N1,N2),X1(N1),X2(N2),DX(2),XV(2)
       DOUBLE PRECISION FUN,UV(2)
       
c- Ix.LE.Nx-1, Nx points, Nx-1 intervals, x=1,2
       I=1  
       DO I=1,N1-1
        IF (XV(1).GE.X1(I).AND.XV(1).LE.X1(I+1)) THEN
        I1=I
        DX(1)=X1(I1+1)-X1(I1)
        UV(1)=(XV(1)-X1(I1))/DX(1)
        ENDIF
       ENDDO
       I=1
       DO I=1,N2-1
        IF (XV(2).GE.X2(I).AND.XV(2).LE.X2(I+1)) THEN
        I2=I
        DX(2)=X2(I2+1)-X2(I2)
        UV(2)=(XV(2)-X2(I2))/DX(2)
        ENDIF
       ENDDO     
       
       FUN=FDT(I1+1,I2+1)+FDT(I1,I2)-FDT(I1+1,I2)-FDT(I1,I2+1)
       FUN=FUN*UV(1)+FDT(I1,I2+1)-FDT(I1,I2)
       FUN=FUN*UV(2)+FDT(I1,I2)+(FDT(I1+1,I2)-FDT(I1,I2))*UV(1)
              
       RETURN
       END
c- Linear interpolation 4-D
       SUBROUTINE LININT4D(FDT,X1,X2,X3,X4,N1,N2,N3,N4,XV,FUN)
       
       IMPLICIT NONE
       INTEGER N1,N2,N3,N4,I1,I2,I3,I4,I
       DOUBLE PRECISION FDT(N1,N2,N3,N4)
       DOUBLE PRECISION X1(N1),X2(N2),X3(N3),X4(N4)
       DOUBLE PRECISION DX(4),XV(4)
       DOUBLE PRECISION FUN,UV(4),F1,F2,FF1,FF2
       
c- Ix.LE.Nx-1, Nx points, Nx-1 intervals, x=1,4
       I=1  
       DO I=1,N1-1
        IF (XV(1).GE.X1(I).AND.XV(1).LE.X1(I+1)) THEN
        I1=I
        DX(1)=X1(I1+1)-X1(I1)
        UV(1)=(XV(1)-X1(I1))/DX(1)
        ENDIF
       ENDDO
       I=1
       DO I=1,N2-1
        IF (XV(2).GE.X2(I).AND.XV(2).LE.X2(I+1)) THEN
        I2=I
        DX(2)=X2(I2+1)-X2(I2)
        UV(2)=(XV(2)-X2(I2))/DX(2)
        ENDIF
       ENDDO        
       I=1
       DO I=1,N3-1
        IF (XV(3).GE.X3(I).AND.XV(3).LE.X3(I+1)) THEN
        I3=I
        DX(3)=X3(I3+1)-X3(I3)
        UV(3)=(XV(3)-X3(I3))/DX(3)
        ENDIF
       ENDDO        
       I=1
       DO I=1,N4-1
        IF (XV(4).GE.X4(I).AND.XV(4).LE.X4(I+1)) THEN
        I4=I
        DX(4)=X4(I4+1)-X4(I4)
        UV(4)=(XV(4)-X4(I4))/DX(4)
        ENDIF
       ENDDO       
       
       F1=FDT(I1+1,I2+1,I3,I4)+FDT(I1,I2,I3,I4)
       F1=F1-FDT(I1+1,I2,I3,I4)-FDT(I1,I2+1,I3,I4)
       F1=F1*UV(1)+FDT(I1,I2+1,I3,I4)-FDT(I1,I2,I3,I4)
       F1=F1*UV(2)+FDT(I1,I2,I3,I4)
       F1=F1+(FDT(I1+1,I2,I3,I4)-FDT(I1,I2,I3,I4))*UV(1)
       
       F2=FDT(I1+1,I2+1,I3+1,I4)+FDT(I1,I2,I3+1,I4)
       F2=F2-FDT(I1+1,I2,I3+1,I4)-FDT(I1,I2+1,I3+1,I4)
       F2=F2*UV(1)+FDT(I1,I2+1,I3+1,I4)-FDT(I1,I2,I3+1,I4)
       F2=F2*UV(2)+FDT(I1,I2,I3+1,I4)
       F2=F2+(FDT(I1+1,I2,I3+1,I4)-FDT(I1,I2,I3+1,I4))*UV(1)
       
       FF1=F1+UV(3)*(F2-F1)

       F1=FDT(I1+1,I2+1,I3,I4+1)+FDT(I1,I2,I3,I4+1)
       F1=F1-FDT(I1+1,I2,I3,I4+1)-FDT(I1,I2+1,I3,I4+1)
       F1=F1*UV(1)+FDT(I1,I2+1,I3,I4+1)-FDT(I1,I2,I3,I4+1)
       F1=F1*UV(2)+FDT(I1,I2,I3,I4+1)
       F1=F1+(FDT(I1+1,I2,I3,I4+1)-FDT(I1,I2,I3,I4+1))*UV(1)
       
       F2=FDT(I1+1,I2+1,I3+1,I4+1)+FDT(I1,I2,I3+1,I4+1)
       F2=F2-FDT(I1+1,I2,I3+1,I4+1)-FDT(I1,I2+1,I3+1,I4+1)
       F2=F2*UV(1)+FDT(I1,I2+1,I3+1,I4+1)-FDT(I1,I2,I3+1,I4+1)
       F2=F2*UV(2)+FDT(I1,I2,I3+1,I4+1)
       F2=F2+(FDT(I1+1,I2,I3+1,I4+1)-FDT(I1,I2,I3+1,I4+1))*UV(1)
       
       FF2=F1+UV(3)*(F2-F1)
       
       FUN=FF1+UV(4)*(FF2-FF1)
          
       RETURN
       END

c-------------------------------------------------------------
c- subroutine to extract tables from files:
c- S2pi.dat,S2rho.dat,S2a2.dat,Spi.dat,Srho.dat,Sa2.dat
c- FFpi.dat,FFrho.dat,FFa2.dat
c- and to make tables for the MC-generation
c-------------------------------------------------------------
      SUBROUTINE CEPUTDAT
      
      IMPLICIT NONE
    
C-... model parameters
      EXTERNAL NTAB
      INTEGER I
c- cross-sections
      DOUBLE PRECISION DCSCE0,DCSDCE0,SIGTOTRR,SIGTOTRP
c--------- general parameters ------------------------ 
      DOUBLE PRECISION XSQ,PI,MPI,MP,MN,MRHO,MA2
      DOUBLE PRECISION XIMIN,XIMAX,QTMIN,QTMAX
      DOUBLE PRECISION API,ARHO,AA2,R2PI,R2RHO,R2A2
      DOUBLE PRECISION GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION S
      INTEGER NMODPP,NMODRR,ITYPR
      COMMON/PNTAB0/S,NMODPP,NMODRR,ITYPR
      COMMON/PNTAB1/XSQ(6),PI,MPI,MP,MN,MRHO,MA2
      COMMON/PNTAB2/XIMIN,XIMAX,QTMIN,QTMAX
      COMMON/PNTAB3/API,ARHO,AA2,R2PI,R2RHO,R2A2
      COMMON/PNTAB4/GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
c--------- tables for absorbtion and form-factors ----
      DOUBLE PRECISION SSPI,SSRHO,SSA2,SDPIS,SDPIA,
     & SDRHOS,SDRHOA,SDA2S,SDA2A,FFDPI,FFDRHO,FFDA2     
      DOUBLE PRECISION XSSPI,XSSRHO,XSSA2,XSDPIS,XSDPIA,
     & XSDRHOS,XSDRHOA,XSDA2S,XSDA2A,XFFDPI,XFFDRHO,XFFDA2
      DOUBLE PRECISION SPI,SRHO,SA2,DPI,DRHO,DA2,
     & FDPI,FDRHO,FDA2     
      DOUBLE PRECISION SPIX1,SPIX2,SPIXQ,SROX1,SROX2,SROXQ,
     & SA2X1,SA2X2,SA2XQ,DPIX1,DPIX2,DPIXX,
     & DROX1,DROX2,DROXX,DA2X1,DA2X2,DA2XX,
     & DDPI1,DDPI2,DDPI3,DDRO1,DDRO2,DDRO3,
     & DDA21,DDA22,DDA23
      COMMON/CEDATGET/SSPI(6,53,41),SSRHO(6,53,51),
     & SSA2(6,53,51),SDPIS(6,10,8,9,8),SDPIA(6,10,8,9,8),
     & SDRHOS(6,10,8,9,8),SDRHOA(6,10,8,9,8),SDA2S(6,10,8,9,8),     
     & SDA2A(6,10,8,9,8),FFDPI(6,60,16),FFDRHO(6,60,16),
     & FFDA2(6,60,16)     
      COMMON/CEDATFIX/XSSPI(53,41),XSSRHO(53,51),
     & XSSA2(53,51),XSDPIS(10,8,9,8),XSDPIA(10,8,9,8),
     & XSDRHOS(10,8,9,8),XSDRHOA(10,8,9,8),XSDA2S(10,8,9,8),     
     & XSDA2A(10,8,9,8),XFFDPI(60,16),XFFDRHO(60,16),
     & XFFDA2(60,16)
      COMMON/CEDATMOD/SPI(41,41),SRHO(41,41),SA2(41,41),
     & DPI(17,17,17,17),DRHO(17,17,17,17),DA2(17,17,17,17),
     & FDPI(17,17),FDRHO(17,17),FDA2(17,17)
      COMMON/CEDATGEN/SPIX1(41),SPIX2(41),SPIXQ(2,41,41),
     & SROX1(41),SROX2(41),SROXQ(2,41,41),
     & SA2X1(41),SA2X2(41),SA2XQ(2,41,41),
     & DPIX1(17),DPIX2(17),DPIXX(2,17,17),
     & DROX1(17),DROX2(17),DROXX(2,17,17),
     & DA2X1(17),DA2X2(17),DA2XX(2,17,17),
     & DDPI1(4,17,17,17),DDPI2(4,17,17,17),DDPI3(8,17,17,17,17),
     & DDRO1(4,17,17,17),DDRO2(4,17,17,17),DDRO3(8,17,17,17,17),
     & DDA21(4,17,17,17),DDA22(4,17,17,17),DDA23(8,17,17,17,17)
c- arrays for variables
      DOUBLE PRECISION VXIR,VFIS,VFIA,VQTR,
     & VXIRF,VFIF,VXI,VQT,SVXI,SVQT,DVXI,DVQT 
      COMMON/CEDATVARS/VXIR(10),VFIS(8),VFIA(8),VQTR(9),
     & VXIRF(60),VFIF(16),VXI(53),VQT(41),
     & SVXI(41),SVQT(41),DVXI(17),DVQT(17) 
 
      INTEGER IX,IQ,IX1,IX2,IQ1,IQ2,IDS,IXR,IQR,IFIX,IFIQ
      DOUBLE PRECISION FFF(6),FFFF,XV2(2),XV4(4),XVR4(4),XVR2(2)
      DOUBLE PRECISION AU1,AU2
      CHARACTER*6 FILES(3)
      CHARACTER*7 FILES2(3),FILEFF(3) 

c- reading tables from files
       IF (NMODPP.EQ.1) THEN
        FILES(1)='Spi_1'
        FILES(2)='Sro_1'
        FILES(3)='Sa2_1'
        FILES2(1)='S2pi_1'
        FILES2(2)='S2ro_1'
        FILES2(3)='S2a2_1'
        FILEFF(1)='FFpi_1'
        FILEFF(2)='FFro_1'
        FILEFF(3)='FFa2_1'      
       ENDIF
       IF (NMODPP.EQ.2) THEN
        FILES(1)='Spi_2'
        FILES(2)='Sro_2'
        FILES(3)='Sa2_2'
        FILES2(1)='S2pi_2'
        FILES2(2)='S2ro_2'
        FILES2(3)='S2a2_2'
        FILEFF(1)='FFpi_2'
        FILEFF(2)='FFro_2'
        FILEFF(3)='FFa2_2'      
       ENDIF
       IF (NMODPP.EQ.3) THEN
        FILES(1)='Spi_3'
        FILES(2)='Sro_3'
        FILES(3)='Sa2_3'
        FILES2(1)='S2pi_3'
        FILES2(2)='S2ro_3'
        FILES2(3)='S2a2_3'
        FILEFF(1)='FFpi_3'
        FILEFF(2)='FFro_3'
        FILEFF(3)='FFa2_3'      
       ENDIF       
c- DCE absorbtion tables  
       OPEN(33,FILE=FILES2(1),STATUS='OLD')
       OPEN(44,FILE=FILES2(2),STATUS='OLD')
       OPEN(55,FILE=FILES2(3),STATUS='OLD')
       IDS=1 
       DO IDS=1,6
        IXR=1
        IFIX=1
        IQR=1
        IFIQ=1
        DO IXR=1,10
         DO IFIX=1,8
          DO IQR=1,9
           DO IFIQ=1,8            
           READ(33,*)SDPIS(IDS,IXR,IFIX,IQR,IFIQ)
           READ(44,*)SDRHOS(IDS,IXR,IFIX,IQR,IFIQ)
           READ(55,*)SDA2S(IDS,IXR,IFIX,IQR,IFIQ)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        IXR=1
        IFIX=1
        IQR=1
        IFIQ=1
        DO IXR=1,10
         DO IFIX=1,8
          DO IQR=1,9
           DO IFIQ=1,8            
           READ(33,*)SDPIA(IDS,IXR,IFIX,IQR,IFIQ)
           READ(44,*)SDRHOA(IDS,IXR,IFIX,IQR,IFIQ)
           READ(55,*)SDA2A(IDS,IXR,IFIX,IQR,IFIQ)
           ENDDO
          ENDDO
         ENDDO
        ENDDO         
       ENDDO
       CLOSE(55)
       CLOSE(44)
       CLOSE(33)

c- CE absorbtion tables       
       OPEN(33,FILE=FILES(1),STATUS='OLD')
       OPEN(44,FILE=FILES(2),STATUS='OLD')
       OPEN(55,FILE=FILES(3),STATUS='OLD')
       IDS=1 
       DO IDS=1,6
        IX=1
        IQ=1
        DO IX=1,53
         DO IQ=1,41                     
           READ(33,*)SSPI(IDS,IX,IQ)
           READ(44,*)SSRHO(IDS,IX,IQ)
           READ(55,*)SSA2(IDS,IX,IQ)           
         ENDDO
        ENDDO       
       ENDDO
       CLOSE(55)
       CLOSE(44)
       CLOSE(33)
       
c- DCE form-factors(xir,phi_xir->xi1,xi2)       
       OPEN(33,FILE=FILEFF(1),STATUS='OLD')
       OPEN(44,FILE=FILEFF(2),STATUS='OLD')
       OPEN(55,FILE=FILEFF(3),STATUS='OLD')
       IDS=1 
       DO IDS=1,6
        IXR=1
        IFIX=1
        DO IXR=1,60
         DO IFIX=1,16                     
           READ(33,*)FFDPI(IDS,IXR,IFIX)
           READ(44,*)FFDRHO(IDS,IXR,IFIX)
           READ(55,*)FFDA2(IDS,IXR,IFIX)           
         ENDDO
        ENDDO       
       ENDDO
       CLOSE(55)
       CLOSE(44)
       CLOSE(33)       

c-- interpolation to the fixed value of S
c- DCE absorbtion tables       
        IXR=1
        IFIX=1
        IQR=1
        IFIQ=1
        DO IXR=1,10
         DO IFIX=1,8
          DO IQR=1,9           
           DO IFIQ=1,8  
            IDS=1    
            DO IDS=1,6
             FFF(IDS)=SDPIS(IDS,IXR,IFIX,IQR,IFIQ)
            ENDDO
            CALL CUBINTLNSQ(FFF,S,FFFF)
            XSDPIS(IXR,IFIX,IQR,IFIQ)=FFFF
            IDS=1    
            DO IDS=1,6
             FFF(IDS)=SDRHOS(IDS,IXR,IFIX,IQR,IFIQ)
            ENDDO
            CALL CUBINTLNSQ(FFF,S,FFFF)
            XSDRHOS(IXR,IFIX,IQR,IFIQ)=FFFF
            IDS=1    
            DO IDS=1,6
             FFF(IDS)=SDA2S(IDS,IXR,IFIX,IQR,IFIQ)
            ENDDO
            CALL CUBINTLNSQ(FFF,S,FFFF)
            XSDA2S(IXR,IFIX,IQR,IFIQ)=FFFF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        IXR=1
        IFIX=1
        IQR=1
        IFIQ=1
        DO IXR=1,10
         DO IFIX=1,8
          DO IQR=1,9
           DO IFIQ=1,8            
            IDS=1    
            DO IDS=1,6
             FFF(IDS)=SDPIA(IDS,IXR,IFIX,IQR,IFIQ)
            ENDDO
            CALL CUBINTLNSQ(FFF,S,FFFF)
            XSDPIA(IXR,IFIX,IQR,IFIQ)=FFFF
            IDS=1    
            DO IDS=1,6
             FFF(IDS)=SDRHOA(IDS,IXR,IFIX,IQR,IFIQ)
            ENDDO
            CALL CUBINTLNSQ(FFF,S,FFFF)
            XSDRHOA(IXR,IFIX,IQR,IFIQ)=FFFF
            IDS=1    
            DO IDS=1,6
             FFF(IDS)=SDA2A(IDS,IXR,IFIX,IQR,IFIQ)
            ENDDO
            CALL CUBINTLNSQ(FFF,S,FFFF)
            XSDA2A(IXR,IFIX,IQR,IFIQ)=FFFF
           ENDDO
          ENDDO
         ENDDO
        ENDDO         
       
c- CE absorbtion tables       
        IX=1
        IQ=1
        DO IX=1,53
         DO IQ=1,41                     
          IDS=1 
          DO IDS=1,6
           FFF(IDS)=SSPI(IDS,IX,IQ)
          ENDDO
          CALL CUBINTLNSQ(FFF,S,FFFF)
          XSSPI(IX,IQ)=FFFF
          IDS=1 
          DO IDS=1,6
           FFF(IDS)=SSRHO(IDS,IX,IQ)
          ENDDO
          CALL CUBINTLNSQ(FFF,S,FFFF)
          XSSRHO(IX,IQ)=FFFF          
          IDS=1 
          DO IDS=1,6
           FFF(IDS)=SSA2(IDS,IX,IQ)
          ENDDO
          CALL CUBINTLNSQ(FFF,S,FFFF)
          XSSA2(IX,IQ)=FFFF                     
         ENDDO
        ENDDO       
               
c- DCE form-factors(xir,phi_xir->xi1,xi2)       
      
        IXR=1
        IFIX=1
        DO IXR=1,60
         DO IFIX=1,16 
          IDS=1 
          DO IDS=1,6
           FFF(IDS)=FFDPI(IDS,IXR,IFIX)
          ENDDO
          CALL CUBINTLNSQ(FFF,S,FFFF)
          XFFDPI(IXR,IFIX)=FFFF
          IDS=1 
          DO IDS=1,6
           FFF(IDS)=FFDRHO(IDS,IXR,IFIX)
          ENDDO
          CALL CUBINTLNSQ(FFF,S,FFFF)
          XFFDRHO(IXR,IFIX)=FFFF
          IDS=1 
          DO IDS=1,6
           FFF(IDS)=FFDA2(IDS,IXR,IFIX)
          ENDDO
          CALL CUBINTLNSQ(FFF,S,FFFF)
          XFFDA2(IXR,IFIX)=FFFF          
         ENDDO
        ENDDO       

c-- modification to uniform divisions for the interpolation
c-- definition of variables (tables) ---
c- VXIR(10),VFIS(8),VFIA(8),VQTR(9),VXIRF(60),VFIF(16)
        VXIR(1)=0.0001D0
        VXIR(2)=0.0025D0
        VXIR(3)=0.02D0
        VXIR(4)=0.05D0
        VXIR(5)=0.15D0
        VXIR(6)=0.2D0
        VXIR(7)=0.25D0
        VXIR(8)=0.3D0
        VXIR(9)=0.4D0
        VXIR(10)=0.4D0*DSQRT(2.D0)

        VFIS(1)=1.0D-07
        VFIS(2)=0.0049D0
        VFIS(3)=0.0145D0
        VFIS(4)=0.0873D0
        VFIS(5)=0.131D0
        VFIS(6)=0.2618D0
        VFIS(7)=0.5236D0
        VFIS(8)=PI/4.D0

        DO I=1,7 
        VFIA(I)=PI/2.D0-VFIS(9-I)
        ENDDO
        VFIA(8)=PI*0.5D0*(1.D0-1.D-07)
        
        VQTR(1)=0.0001D0
        VQTR(2)=0.01D0
        VQTR(3)=0.03D0
        VQTR(4)=0.06D0
        VQTR(5)=0.11D0
        VQTR(6)=0.18D0
        VQTR(7)=0.3D0
        VQTR(8)=0.47D0
        VQTR(9)=0.5D0*DSQRT(2.D0)

        VXIRF(1)=0.0001D0
        VXIRF(2)=0.0025D0
        VXIRF(3)=0.005D0
        DO I=4,60
        VXIRF(I)=0.01D0*(I-3)
        ENDDO
        
        VFIF(1)=1.D-07
        VFIF(2)=1.D-05
        VFIF(3)=1.D-04
        VFIF(4)=PI/4.D0/0.648D+03
        VFIF(5)=2.D0*VFIF(4)
        VFIF(6)=2.D0*VFIF(5)
        VFIF(7)=2.D0*VFIF(6)
        VFIF(8)=PI/4.D0/0.54D+02
        VFIF(9)=2.D0*VFIF(8)
        VFIF(10)=3.D0*VFIF(9)
        VFIF(11)=PI/0.24D+02
        VFIF(12)=PI/0.16D+02
        VFIF(13)=PI/0.12D+02
        VFIF(14)=PI/8.D0
        VFIF(15)=PI/6.D0
        VFIF(16)=PI/4.D0
c- VXI(53),VQT(41),SVXI(40),SVQT(40),DVXI(17),DVQT(17)
        VXI(1)=0.0001D0
        DO I=1,4
        VXI(I+1)=0.0002D0*I
        ENDDO
        DO I=1,9
        VXI(I+5)=0.001D0*I
        VXI(I+14)=0.01D0*I
        ENDDO
        DO I=1,30
        VXI(I+23)=0.1D0+0.01D0*I
        ENDDO
        VQT(1)=0.0001D0
        VQT(2)=0.0005D0
        DO I=1,9
        VQT(I+2)=0.001D0*I
        VQT(I+11)=0.01D0*I
        ENDDO
        DO I=1,21
        VQT(I+20)=0.1D0+0.02D0*(I-1)
        ENDDO
          
        SVXI(1)=0.0001D0
        SVQT(1)=0.0001D0
        DO I=2,41
         SVXI(I)=0.01D0*(I-1)
         SVQT(I)=0.5D0*(I-1)/40.D0
        ENDDO
        
        DVXI(1)=0.01D0
        DVQT(1)=0.0001D0
        DO I=2,17
         DVXI(I)=0.4D0*(I-1)/16.D0
         DVQT(I)=0.5D0*(I-1)/16.D0
        ENDDO
                
c-- recalculation of tables and cross-sections to uniform meshes
c-- SCE
        IX=1
        IQ=1
        DO IX=1,41
         XV2(1)=SVXI(IX)
         DO IQ=1,41
          XV2(2)=SVQT(IQ)
          CALL LININT2D(XSSPI,VXI,VQT,53,41,XV2,FFFF)   
          SPI(IX,IQ)=FFFF*DCSCE0(1,XV2(1),XV2(2))
          CALL LININT2D(XSSRHO,VXI,VQT,53,41,XV2,FFFF)   
          SRHO(IX,IQ)=FFFF*DCSCE0(2,XV2(1),XV2(2))
          CALL LININT2D(XSSA2,VXI,VQT,53,41,XV2,FFFF)   
          SA2(IX,IQ)=FFFF*DCSCE0(3,XV2(1),XV2(2))
         ENDDO
        ENDDO 
c-- DCE full 4D
        IX1=1
        IX2=1
        IQ1=1
        IQ2=1
        AU1=PI/4.D0
        AU2=PI/4.D0
        DO IX1=1,17
         XV4(1)=DVXI(IX1)        
         DO IX2=1,17
          XV4(2)=DVXI(IX2)         
          DO IQ1=1,17
           XV4(3)=DVQT(IQ1)          
           DO IQ2=1,17
            XV4(4)=DVQT(IQ2)
            XVR4(1)=DSQRT(XV4(1)**2+XV4(2)**2)
            XVR4(2)=DATAN(XV4(2)/XV4(1))
            XVR4(3)=DSQRT(XV4(3)**2+XV4(4)**2)
            XVR4(4)=DATAN(XV4(4)/XV4(3))
            IF (XVR4(4).LE.AU1) THEN
             IF (XVR4(2).LE.AU1) THEN
              CALL LININT4D(XSDPIS,VXIR,VFIS,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF) 
              FFFF=FFFF*DCSDCE0(1,XV4(1),XV4(2),XV4(3),XV4(4))
              DPI(IX1,IX2,IQ1,IQ2)=FFFF
              CALL LININT4D(XSDRHOS,VXIR,VFIS,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF) 
              FFFF=FFFF*DCSDCE0(2,XV4(1),XV4(2),XV4(3),XV4(4))
              DRHO(IX1,IX2,IQ1,IQ2)=FFFF
              CALL LININT4D(XSDA2S,VXIR,VFIS,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF) 
              FFFF=FFFF*DCSDCE0(3,XV4(1),XV4(2),XV4(3),XV4(4))
              DA2(IX1,IX2,IQ1,IQ2)=FFFF              
             ELSE
              CALL LININT4D(XSDPIA,VXIR,VFIA,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF) 
              FFFF=FFFF*DCSDCE0(1,XV4(1),XV4(2),XV4(3),XV4(4))
              DPI(IX1,IX2,IQ1,IQ2)=FFFF
              CALL LININT4D(XSDRHOA,VXIR,VFIA,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF)
              FFFF=FFFF*DCSDCE0(2,XV4(1),XV4(2),XV4(3),XV4(4))
              DRHO(IX1,IX2,IQ1,IQ2)=FFFF
              CALL LININT4D(XSDA2A,VXIR,VFIA,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF)
              FFFF=FFFF*DCSDCE0(3,XV4(1),XV4(2),XV4(3),XV4(4))
              DA2(IX1,IX2,IQ1,IQ2)=FFFF
             ENDIF
            ELSE
             AU2=PI/2.D0-XVR4(4)
             XVR4(4)=AU2
             IF (XVR4(2).LE.AU1) THEN
              AU2=PI/2.D0-XVR4(2)
              XVR4(2)=AU2
              CALL LININT4D(XSDPIA,VXIR,VFIA,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF) 
              FFFF=FFFF*DCSDCE0(1,XV4(1),XV4(2),XV4(3),XV4(4))
              DPI(IX1,IX2,IQ1,IQ2)=FFFF
              CALL LININT4D(XSDRHOA,VXIR,VFIA,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF)
              FFFF=FFFF*DCSDCE0(2,XV4(1),XV4(2),XV4(3),XV4(4))
              DRHO(IX1,IX2,IQ1,IQ2)=FFFF
              CALL LININT4D(XSDA2A,VXIR,VFIA,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF)
              FFFF=FFFF*DCSDCE0(3,XV4(1),XV4(2),XV4(3),XV4(4))
              DA2(IX1,IX2,IQ1,IQ2)=FFFF	                   
	     ELSE
              AU2=PI/2.D0-XVR4(2)
              XVR4(2)=AU2
              CALL LININT4D(XSDPIS,VXIR,VFIS,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF)
              FFFF=FFFF*DCSDCE0(1,XV4(1),XV4(2),XV4(3),XV4(4))
              DPI(IX1,IX2,IQ1,IQ2)=FFFF
              CALL LININT4D(XSDRHOS,VXIR,VFIS,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF) 
              FFFF=FFFF*DCSDCE0(2,XV4(1),XV4(2),XV4(3),XV4(4))  
              DRHO(IX1,IX2,IQ1,IQ2)=FFFF
              CALL LININT4D(XSDA2S,VXIR,VFIS,VQTR,VFIS,
     & 10,8,9,8,XVR4,FFFF)
              FFFF=FFFF*DCSDCE0(3,XV4(1),XV4(2),XV4(3),XV4(4))
              DA2(IX1,IX2,IQ1,IQ2)=FFFF 	     
             ENDIF            
            ENDIF  
           ENDDO
          ENDDO
         ENDDO
        ENDDO
c-- DCE xi1,xi2 -> 2D
        IX1=1
        IX2=1
        AU1=PI/4.D0
        AU2=PI/2.D0
        DO IX1=1,17
         XV2(1)=DVXI(IX1)
         DO IX2=1,17
          XV2(2)=DVXI(IX2)
          XVR2(1)=DSQRT(XV2(1)**2+XV2(2)**2)
          XVR2(2)=DATAN(XV2(2)/XV2(1))
          IF (XVR2(2).GT.AU1) THEN           
          AU2=PI/2.D0-XVR2(2)
          XVR2(2)=AU2          
          ENDIF
           CALL LININT2D(XFFDPI,VXIRF,VFIF,60,16,XVR2,FFFF)
           FFFF=FFFF*SIGTOTRR(1,NMODRR,XV2(1)*XV2(2)*S)
           FDPI(IX1,IX2)=FFFF
           CALL LININT2D(XFFDRHO,VXIRF,VFIF,60,16,XVR2,FFFF)
           FFFF=FFFF*SIGTOTRR(2,NMODRR,XV2(1)*XV2(2)*S)
           FDRHO(IX1,IX2)=FFFF
           CALL LININT2D(XFFDA2,VXIRF,VFIF,60,16,XVR2,FFFF)
           FFFF=FFFF*SIGTOTRR(3,NMODRR,XV2(1)*XV2(2)*S)
           FDA2(IX1,IX2)=FFFF              
         ENDDO
        ENDDO 
c-- calculation of integral tables for generations
c-- CE
       CALL INTEG2DTAB(SPI,SVXI,SVQT,41,41,SPIX1,SPIX2,SPIXQ)
       CALL INTEG2DTAB(SRHO,SVXI,SVQT,41,41,SROX1,SROX2,SROXQ)
       CALL INTEG2DTAB(SA2,SVXI,SVQT,41,41,SA2X1,SA2X2,SA2XQ)
c-- DCE xi1,xi2 tables 2D
       CALL INTEG2DTAB(FDPI,DVXI,DVXI,17,17,DPIX1,DPIX2,DPIXX)
       CALL INTEG2DTAB(FDRHO,DVXI,DVXI,17,17,DROX1,DROX2,DROXX)
       CALL INTEG2DTAB(FDA2,DVXI,DVXI,17,17,DA2X1,DA2X2,DA2XX)
c-- DCE tables 4D
       CALL INTEG4DTAB(DPI,DVXI,DVQT,17,17,DDPI1,DDPI2,DDPI3)
       CALL INTEG4DTAB(DRHO,DVXI,DVQT,17,17,DDRO1,DDRO2,DDRO3)
       CALL INTEG4DTAB(DA2,DVXI,DVQT,17,17,DDA21,DDA22,DDA23)

      RETURN
      END

      SUBROUTINE INTEG4DTAB(FF,X1,X2,N1,N2,FF1,FF2,FF3)
      
      IMPLICIT NONE
      INTEGER N1,N2,I,IX1,IX2,IQ1,IQ2
      DOUBLE PRECISION FF(N1,N1,N2,N2),
     & FF1(4,N1,N1,N2),FF2(4,N1,N1,N2),FF3(8,N1,N1,N2,N2)
      DOUBLE PRECISION X1(N1),X2(N2)
      DOUBLE PRECISION AIN(N2,N2),AOU1(N2),
     & AOU2(N2),AOU3(2,N2,N2),AU1,AU2      
      
       DO IX1=1,N1
        DO IX2=1,N1
c- input-1 
         DO IQ1=1,N2
          DO IQ2=1,N2
           AIN(IQ1,IQ2)=FF(IX1,IX2,IQ1,IQ2) 
          ENDDO
         ENDDO 
c- calc.-1
         CALL INTEG2DTAB(AIN,X2,X2,N2,N2,AOU1,AOU2,AOU3)
c- output-1
         DO IQ1=1,N2 
          FF1(1,IX1,IX2,IQ1)=AOU1(IQ1)
          FF2(1,IX1,IX2,IQ1)=AOU2(IQ1)
          DO IQ2=1,N2
           FF3(1,IX1,IX2,IQ1,IQ2)=AOU3(1,IQ1,IQ2)
           FF3(5,IX1,IX2,IQ1,IQ2)=AOU3(2,IQ1,IQ2)
          ENDDO     
         ENDDO
        ENDDO
       ENDDO 
c- output for IX1,IX2<N1
       DO IX1=1,N1-1
        DO IX2=1,N1-1                  
          DO IQ1=1,N2
           AU1=FF1(1,IX1,IX2,IQ1)
           FF1(2,IX1,IX2,IQ1)=FF1(1,IX1+1,IX2,IQ1)-AU1
           FF1(3,IX1,IX2,IQ1)=FF1(1,IX1,IX2+1,IQ1)-AU1
           AU1=AU1+FF1(1,IX1+1,IX2+1,IQ1)
           AU1=AU1-FF1(1,IX1+1,IX2,IQ1)-FF1(1,IX1,IX2+1,IQ1)
           FF1(4,IX1,IX2,IQ1)=AU1
           AU1=FF2(1,IX1,IX2,IQ1)
           FF2(2,IX1,IX2,IQ1)=FF2(1,IX1+1,IX2,IQ1)-AU1
	   FF2(3,IX1,IX2,IQ1)=FF2(1,IX1,IX2+1,IQ1)-AU1
	   AU1=AU1+FF2(1,IX1+1,IX2+1,IQ1)
	   AU1=AU1-FF2(1,IX1+1,IX2,IQ1)-FF2(1,IX1,IX2+1,IQ1)
           FF2(4,IX1,IX2,IQ1)=AU1
           DO IQ2=1,N2
            AU1=FF3(1,IX1,IX2,IQ1,IQ2)
            FF3(2,IX1,IX2,IQ1,IQ2)=FF3(1,IX1+1,IX2,IQ1,IQ2)-AU1
            FF3(3,IX1,IX2,IQ1,IQ2)=FF3(1,IX1,IX2+1,IQ1,IQ2)-AU1 
            AU1=AU1+FF3(1,IX1+1,IX2+1,IQ1,IQ2)
            AU1=AU1-FF3(1,IX1+1,IX2,IQ1,IQ2)
            AU1=AU1-FF3(1,IX1,IX2+1,IQ1,IQ2)
            FF3(4,IX1,IX2,IQ1,IQ2)=AU1 
c-
            AU1=FF3(5,IX1,IX2,IQ1,IQ2)
            FF3(6,IX1,IX2,IQ1,IQ2)=FF3(5,IX1+1,IX2,IQ1,IQ2)-AU1
            FF3(7,IX1,IX2,IQ1,IQ2)=FF3(5,IX1,IX2+1,IQ1,IQ2)-AU1 
            AU1=AU1+FF3(5,IX1+1,IX2+1,IQ1,IQ2)
            AU1=AU1-FF3(5,IX1+1,IX2,IQ1,IQ2)
            AU1=AU1-FF3(5,IX1,IX2+1,IQ1,IQ2)
            FF3(8,IX1,IX2,IQ1,IQ2)=AU1
           ENDDO
          ENDDO                  
        ENDDO
       ENDDO 
c- IX1<N1,IX2=N1 OR IX2<N1,IX1=N1
       DO I=1,N1-1
        DO IQ1=1,N2
           AU1=FF1(1,I,N1,IQ1)
           AU2=FF1(1,N1,I,IQ1)
           FF1(2,I,N1,IQ1)=FF1(1,I+1,N1,IQ1)-AU1
           FF1(3,N1,I,IQ1)=FF1(1,N1,I+1,IQ1)-AU2
           FF1(4,N1,I,IQ1)=0.D0
           FF1(4,I,N1,IQ1)=0.D0
c-
           AU1=FF2(1,I,N1,IQ1)
           AU2=FF2(1,N1,I,IQ1)
           FF2(2,I,N1,IQ1)=FF2(1,I+1,N1,IQ1)-AU1
           FF2(3,N1,I,IQ1)=FF2(1,N1,I+1,IQ1)-AU2
           FF2(4,N1,I,IQ1)=0.D0
           FF2(4,I,N1,IQ1)=0.D0                 
         DO IQ2=1,N2
            AU1=FF3(1,I,N1,IQ1,IQ2)
            AU2=FF3(1,N1,I,IQ1,IQ2)
            FF3(2,I,N1,IQ1,IQ2)=FF3(1,I+1,N1,IQ1,IQ2)-AU1
            FF3(3,N1,I,IQ1,IQ2)=FF3(1,N1,I+1,IQ1,IQ2)-AU2
            FF3(4,I,N1,IQ1,IQ2)=0.D0
            FF3(4,N1,I,IQ1,IQ2)=0.D0
c-
            AU1=FF3(5,I,N1,IQ1,IQ2)
            AU2=FF3(5,N1,I,IQ1,IQ2)
            FF3(6,I,N1,IQ1,IQ2)=FF3(5,I+1,N1,IQ1,IQ2)-AU1
            FF3(7,N1,I,IQ1,IQ2)=FF3(5,N1,I+1,IQ1,IQ2)-AU2
            FF3(8,I,N1,IQ1,IQ2)=0.D0
            FF3(8,N1,I,IQ1,IQ2)=0.D0         
         ENDDO
        ENDDO
       ENDDO
c- IX1=IX2=N1
        DO IQ1=1,N2           
           FF1(2,N1,N1,IQ1)=0.D0
           FF1(3,N1,N1,IQ1)=0.D0
           FF1(4,N1,N1,IQ1)=0.D0
           FF1(4,N1,N1,IQ1)=0.D0
c-
           FF2(2,N1,N1,IQ1)=0.D0
           FF2(3,N1,N1,IQ1)=0.D0
           FF2(4,N1,N1,IQ1)=0.D0
           FF2(4,N1,N1,IQ1)=0.D0               
         DO IQ2=1,N2
            FF3(2,N1,N1,IQ1,IQ2)=0.D0
            FF3(3,N1,N1,IQ1,IQ2)=0.D0
            FF3(4,N1,N1,IQ1,IQ2)=0.D0
            FF3(4,N1,N1,IQ1,IQ2)=0.D0
c-
            FF3(6,N1,N1,IQ1,IQ2)=0.D0
            FF3(7,N1,N1,IQ1,IQ2)=0.D0
            FF3(8,N1,N1,IQ1,IQ2)=0.D0
            FF3(8,N1,N1,IQ1,IQ2)=0.D0     
         ENDDO
        ENDDO

       RETURN
       END

c--- 4 2D integral tables calculation
      SUBROUTINE INTEG2DTAB(FF,X1,X2,N1,N2,FF1,FF2,FF3)
      
      IMPLICIT NONE
      INTEGER N1,N2,IN1,IN2,I
      DOUBLE PRECISION FF(N1,N2),FF1(N1),FF2(N1)
      DOUBLE PRECISION FF3(2,N1,N2)
      DOUBLE PRECISION DX1,DX2,X1(N1),X2(N2)
      DOUBLE PRECISION AU1,AU2
      
      FF2(1)=0.D0
      AU1=0.D0       
      DO I=1,N2-1
       DX2=(X2(I+1)-X2(I))
       AU1=AU1+0.5D0*DX2*(FF(1,I)+FF(1,I+1))         
      ENDDO
      FF1(1)=AU1      
      DO IN1=2,N1
       AU1=0.D0       
       DO I=1,N2-1
       DX2=(X2(I+1)-X2(I))
       AU1=AU1+0.5D0*DX2*(FF(IN1,I)+FF(IN1,I+1))         
       ENDDO
       FF1(IN1)=AU1
       DX1=(X1(IN1)-X1(IN1-1))
       FF2(IN1)=FF2(IN1-1)+0.5D0*DX1*(FF1(IN1-1)+FF1(IN1))       
      ENDDO

      DO IN1=1,N1
       FF3(1,IN1,1)=0.D0             
       DO IN2=2,N2
        DX2=X2(IN2)-X2(IN2-1)
        AU1=0.5D0*DX2*(FF(IN1,IN2-1)+FF(IN1,IN2))
        FF3(1,IN1,IN2)=FF3(1,IN1,IN2-1)+AU1        
       ENDDO
      ENDDO

      DO IN1=1,N1-1
       DO IN2=1,N2
        FF3(2,IN1,IN2)=FF3(1,IN1+1,IN2)-FF3(1,IN1,IN2)
       ENDDO
      ENDDO

      DO IN2=1,N2
        FF3(2,N1,IN2)=0.D0
      ENDDO
       
      RETURN
      END

c-------------------------------------------------------------              
c-... data for neutron subroutines !R.Ryutin
c-------------------------------------------------------------              
      BLOCK DATA NTAB

      IMPLICIT NONE            
c-------------------------------------------------------------
c--------- general parameters ------------------------ 
      DOUBLE PRECISION XSQ,PI,MPI,MP,MN,MRHO,MA2
      DOUBLE PRECISION XIMIN,XIMAX,QTMIN,QTMAX
      DOUBLE PRECISION API,ARHO,AA2,R2PI,R2RHO,R2A2
      DOUBLE PRECISION GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2
      DOUBLE PRECISION S
      INTEGER NMODPP,NMODRR,ITYPR
      COMMON/PNTAB0/S,NMODPP,NMODRR,ITYPR
      COMMON/PNTAB1/XSQ(6),PI,MPI,MP,MN,MRHO,MA2
      COMMON/PNTAB2/XIMIN,XIMAX,QTMIN,QTMAX
      COMMON/PNTAB3/API,ARHO,AA2,R2PI,R2RHO,R2A2
      COMMON/PNTAB4/GPI,GRHO,GA2,SIGRSQ,KARHO,KAA2 
                                    
c-- input parameters (include to the card-file!) 
c-- NMODPP- model for absorption
c-- NMODRR - model for reggeon-proton or reggeon-reggeon
c-- cross-sections
c-------------------------------------------------------
c-- NMODPP=1 by default, our general 3 IP eikonal model
c-- in the future NMODPP=2 -> Godizov,Petrov model,
c-- NMODPP>2 -> other models...
c-------------------------------------------------------
c-- NMODRR=1 -> Donnachie-Landshoff model,
c-- NMODRR=2 -> COMPETE (PDG) model
c-- NMODRR=3 -> Bourreli-Sopfer-Wu model
c-- NMODRR=4 -> Godizov-Petrov model
c-- 0.9 TeV<SQRT(S)<14 TeV!!!
      DATA NMODPP/1/,NMODRR/1/,ITYPR/1/,S/49.0D+06/
c--
c-- other inner parameters
      DATA XSQ/0.9D+03,0.236D+04,0.35D+04,0.5D+04,
     & 0.1D+05,0.14D+05/
      DATA PI/3.141592653589793D0/
      DATA MPI/0.1396D0/,MP/0.9383D0/,MN/0.9396D0/
      DATA MRHO/0.707D0/,MA2/1.3181D0/
c---- XIMAX<0.4!!! QTMAX<0.5!!!      
      DATA XIMAX/0.4D0/,XIMIN/1.D-04/
      DATA QTMAX/0.5D0/,QTMIN/1.D-04/
      DATA API/0.9D0/,ARHO/0.9D0/,AA2/0.9D0/
      DATA R2PI/0.3D0/,R2RHO/2.D0/,R2A2/1.D0/
      DATA GPI/0.1385D+02/,GRHO/0.18D0/,GA2/0.405D0/
      DATA SIGRSQ/2.D0/,KARHO/8.D0/,KAA2/8.D0/
c      
      END
